#-----------------------------------SEGMENTI---------------------------------------

proc segmenti {file} {

#----- resetta le variabili -----

global l
global tiers
global agisci
global tipo
global contenuto
global var_sost
global chosen_enc
array unset agisci
array unset tipo
array unset contenuto
set tiers ""
set nome_tier default
set xmin 0
set xmax 0

if [catch {open $file r} f] {
	cannot read $file
	return
}
fconfigure $f -encoding $chosen_enc

#----- metti nella lista $tiers tutti i tier e per ognuno crea una lista in $contenuti(t$tiercount$nome_tier) con i foni e le durate -----
#----- tiercount serve a impedire che 2 tier con lo stesso nome mandino in crash correlatore dopo -----

set tiercount 0
while {[gets $f riga] >= 0} {
	if {[regexp {name = "(.*)"} $riga tutto nome_tier]} {
		incr tiercount
		if {$nome_tier eq ""} {set nome_tier nameless}
		lappend tiers t$tiercount$nome_tier
		set vc_count(t$tiercount$nome_tier) 0
		set tot_count(t$tiercount$nome_tier) 0
	} elseif {[regexp {xmin = (.*)} $riga tutto parte]} {
		set xmin $parte
	} elseif {[regexp {xmax = (.*)} $riga tutto parte]} {
		set xmax $parte
	} elseif {[regexp {text = "(.*)"} $riga tutto text]} {
		if {$text eq ""} {
			set text "#"
			incr vc_count(t$tiercount$nome_tier)
		} elseif [regexp {text = "[#vcVC]+"} $riga] {
			incr vc_count(t$tiercount$nome_tier)
		}
		incr tot_count(t$tiercount$nome_tier)
		lappend contenuto(t$tiercount$nome_tier) "$text\t[expr ($xmax-$xmin)*1000]"
	}
}
close $f

#----- se non c'è nessun tier, ritorna -----
if {$tiers eq ""} {
	array set mess {
		it "Impossibile procedere alla segmentazione: nessun tier trovato in questo TextGrid."
		en "Cannot proceed to segmentation: no tier has been found in this TextGrid."
	}
	tk_messageBox -message $mess($l)
	return
}


#----- crea un toplevel -----
if {[catch {toplevel .top_tiers} error]} {
	array set mess {it "È già aperta una finestra di segmentazione. È necessario chiuderla prima di procedere." en "A segmentation window is already open. Close it and then retry."}
	tk_messageBox -message $mess($l) -parent .top_tiers
	return
}

catch {. configure -cursor watch; update}
bind .top_tiers <Return> {catch {[focus] invoke}}
wm title .top_tiers [file tail $file]

#configurazioni di grid per controllare il ridimensionamento della finestra
grid propagate .top_tiers 1
grid rowconfigure .top_tiers 0 -weight 1
grid rowconfigure .top_tiers 1 -weight 0
grid columnconfigure .top_tiers 0 -weight 1
grid columnconfigure .top_tiers 1 -weight 0
grid columnconfigure .top_tiers 1 -weight 0

grid [ttk::labelframe .top_tiers.fl -text Tiers] -row 0 -column 0 -padx 5 -pady 5
array set mess {
	it "In questo file sono presenti i seguenti tiers. Selezionare quello che contiene le annotazioni per il calcolo dei correlati e specificare il tipo di annotazione che si è fatta (SAMPA o CV)."
	en "The following tiers were found in the file chosen. Select the one that contains the labels to be used for computing rhythm metrics and specify the type of labelling that was carried out (SAMPA or CV)."
}
grid [message .top_tiers.fl.message -text $mess($l) -width 400] -row 0 -column 0 -columnspan 2 -pady {0 10}
grid [ttk::frame .top_tiers.fl.check] -row 1 -column 0 -columnspan 2

#----- per ogni tier crea un radiobutton e un combobox per la scelta cv/sampa -----
set i 0
foreach tier $tiers {
	incr i
	# v3: _$tier cambiato con $i (funzionale al batch)
	radiobutton .top_tiers.fl.check.cb_$i -text [string range $tier 2 end] -variable scelto -value $tier]
	.top_tiers.fl.check.cb_$i select
	ttk::combobox .top_tiers.fl.check.om_$i -textvariable tipo($tier) -values "CV SAMPA" -width 7
	grid .top_tiers.fl.check.cb_$i .top_tiers.fl.check.om_$i -pady 2 -padx 25
	if {($vc_count($tier) + ($vc_count($tier)/10)) > $tot_count($tier)} {
		set tipo($tier) CV
	} else {
		set tipo($tier) SAMPA
	}
}
array set mess {it "Mostra le metriche per ogni IPU" en "Show metrics IPU by IPU"}
set ::EXTRACT_IPUS 0
grid [ttk::checkbutton .top_tiers.fl.check.ipu -text $mess($l) -variable EXTRACT_IPUS] -columnspan 2 -pady {15 0}

grid [ttk::frame .top_tiers.fl.buttons] -row 2 -column 0 -columnspan 2 -pady {15 0}
array set mess {it Chiudi en Close}
pack [ttk::button .top_tiers.fl.buttons.chiudi -text $mess($l) -command {destroy .top_tiers} -image gif_chiudi -compound left] -side left
array set mess {it Aiuto en Help}
pack [ttk::button .top_tiers.fl.buttons.aiuto -text $mess($l) -command {aiuto} -image gif_aiuto -compound left] -side left
array set mess {it Pulisci en Refresh}
pack [ttk::button .top_tiers.fl.buttons.pulisci -text $mess($l) -command "destroy .top_tiers; segmenti {$file}" -image gif_aggiorna -compound left] -side left
array set mess {it Calcola! en Go!}
pack [ttk::button .top_tiers.fl.buttons.calcola -text $mess($l) -command "avanti \[concat $file\]" -image gif_avanti -compound left] -side left

#segmenti
grid [ttk::frame .top_tiers.fr] -row 0 -column 1 -sticky news
array set mess {it "Segmentazione standard:" en "Standard segmentation:"}
pack [ttk::label .top_tiers.fr.l -text $mess($l)] -pady 3
pack [superscrolled text .top_tiers.fr.paolo.text y -width 20 -height 20 -wrap none] -fill both -expand yes
array set mess {it "Salva su file" en "Save to file"}
pack [ptk::btnSaveAsTxt .top_tiers.fr.button .top_tiers.fr.paolo.text -text $mess($l) -state disabled -image gif_salva -compound left] -fill x

#segmenti CCI
grid [ttk::frame .top_tiers.cci] -row 0 -column 2 -sticky news
array set mess {it "Segmentazione per CCI:" en "Segmentation for CCI:"}
pack [ttk::label .top_tiers.cci.l -text $mess($l)] -pady 3
pack [superscrolled text .top_tiers.cci.paolo.text y -width 20 -height 20 -wrap none] -fill both -expand yes
array set mess {it "Salva su file" en "Save to file"}
pack [ptk::btnSaveAsTxt .top_tiers.cci.button .top_tiers.cci.paolo.text -text $mess($l) -state disabled -image gif_salva -compound left] -fill x

#correlati
grid [ttk::frame .top_tiers.corr] -row 0 -column 3 -sticky news -padx {0 5}
array set mess {it "Correlati:" en "Rhythm metrics:"}
pack [ttk::label .top_tiers.corr.l -text $mess($l)] -pady 3
pack [superscrolled text .top_tiers.corr.paolo.text x -width 50 -height 20 -wrap none] -fill both -expand yes
array set mess {it "Aggiungi a report" en "Add to report"}
pack [ttk::button .top_tiers.corr.button -text $mess($l) -command {scrivi_report} -state disabled -image gif_report -compound left] -fill x

#segmentazione visiva
grid [ttk::frame .top_tiers.draw] -row 1 -column 0 -columnspan 4 -sticky news
pack [ttk::separator .top_tiers.draw.sep] -fill x -expand yes

pack [ttk::frame .top_tiers.draw.ll] -fill x -expand yes

array set mess {it "Segmentazione visiva:" en "Optical segmentation:"}
pack [ttk::label .top_tiers.draw.ll.l -text $mess($l)] -side left -anchor w -padx {5 0} -fill x -expand yes

pack [ttk::frame .top_tiers.draw.ll.fr] -side left -fill x -expand yes
pack [ttk::label .top_tiers.draw.ll.fr.l1 -text "1 pixel = "] -side left
set ::proporzione 5
pack [spinbox .top_tiers.draw.ll.fr.spin -from 1 -to 20 -textvariable proporzione -width 2] -side left
array set mess {it millisecondi en milliseconds}
pack [ttk::label .top_tiers.draw.ll.fr.l2 -text "$mess($l)"] -side left

array set mess {it "Mostra segmenti" en "Show segments"}
pack [ttk::checkbutton .top_tiers.draw.ll.show -variable showsegm -text $mess($l)] -side left -fill x -expand yes
set ::showsegm 1
pack [ttk::frame .top_tiers.draw.ll.f] -side left -fill x -expand yes
array set mess {it "Spessore linea: " en "Line width: "}
pack [ttk::label .top_tiers.draw.ll.f.l3 -text $mess($l)] -side left
pack [spinbox .top_tiers.draw.ll.f.spin2 -from 1 -to 10 -textvariable spessore -width 2] -side left
set ::spessore 4
array set mess {it "Salva come immagine" en "Save as image"}
pack [ptk::btnSaveAsImg .top_tiers.draw.ll.btn .top_tiers.draw.frame.canvas -text "$mess($l)." -direction above] -side right
pack [superscrolled canvas .top_tiers.draw.frame.canvas x -height 40 -width 400 -background white] -fill x -expand yes

#suggerimenti
if {$::tips == 1} {
	array set mess {
		it "Qui vengono mostrati gli intervalli vocalici in blu e gli intervalli consonantici in rosso. È possibile cambiare i colori cliccando sopra le linee."
		en "You can see here the vocalic intervals in blue and the consonantal intervals in red. You can change the colours by clicking on the lines."
	}
	suggerimento .top_tiers.draw.frame.canvas $mess($l)
	array set mess {
		it "Qui viene mostrata la segmentazione in intervalli vocalici e consonantici."
		en "You can see here the segmentation into vocalic and consonantal intervals."
	}
	suggerimento .top_tiers.fr.paolo.text $mess($l)
	array set mess {
		it "Qui viene mostrata la segmentazione in intervalli vocalici e consonantici per i CCI."
		en "You can see here the segmentation into vocalic and consonantal intervals for the CCI."
	}
	suggerimento .top_tiers.cci.paolo.text $mess($l)
	array set mess {
		it "Qui vengono mostrati i valori dei correlati."
		en "You can see here the values of the rhythm metrics."
	}
	suggerimento .top_tiers.corr.paolo.text $mess($l)
}

focus .top_tiers.fl.buttons.calcola
catch {. configure -cursor ""}

}

#-----------------------------------AVANTI---------------------------------------

proc avanti {file} {

global BATCH_IS_RUNNING

#----- finestrella "Calculating..." e cursore di attesa -----
catch {
	#place [label .top_tiers.inf -text Calculating... -font "times 36 bold italic" -fg blue -relief raised -border 3] -in .top_tiers -relx 0.5 -rely 0.5 -anchor center
	.top_tiers configure -cursor watch
}
update

global l
global tiers
global scelto
global tipo
global contenuto
global var_sost
set log ""

#----- correggi scelto perché termina con una "]" -----
if [string match *\] $scelto] {set scelto [string map {\] ""} $scelto]}

#----- pulisci le caselle e dai errore se non c'è nessun tier selezionato -----
.top_tiers.fr.paolo.text delete 1.0 end
.top_tiers.cci.paolo.text delete 1.0 end
.top_tiers.corr.paolo.text delete 1.0 end

set conto 0
foreach tier $tiers {
	if {$scelto eq $tier} {incr conto}
}
if {$conto != 1} {
	array set mess {it "È necessario selezionare un tier." en "You need to select one tier."}
	tk_messageBox -parent .top_tiers -message $mess($l)
	return
}

#----- controlla che il tier non sia vuoto -----
if ![info exists contenuto($scelto)] {
	array set mess {
		it "Impossibile procedere: questo tier sembra essere vuoto: "
		en "Cannot proceed: this tier seems to be empty: "
	}
	tk_messageBox -message $mess($l)[string range $scelto 2 end]. -parent .top_tiers
	.top_tiers configure -cursor ""
	return
}

#----- segmenta, eventualmente trasforma SAMPA e riempi il text con i segmenti -----
.top_tiers.fr.paolo.text insert end "FILE\t[file tail [file rootname $file]]\n"
.top_tiers.cci.paolo.text insert end "FILE\t[file tail [file rootname $file]]\n"
set precedente null
set intervallo ""
set durata 0
set n_intervallo 0
foreach item $contenuto($scelto) {
	
	#----- metti a posto i caratteri che interferiscono con tcl -----
	set item [string map {\" ""} $item]
	set item [string map {\[ \\\[} $item]
	set item [string map {\] \\\]} $item]
	set item [string map {\{ \\\{} $item]
	set item [string map {\} \\\}} $item]
	set item [string map {\\ \\\\} $item]
	
	#----- a = fono ; b = durata -----
	incr n_intervallo
	set a [lindex $item 0]
	set b [lindex $item 1]
	if {$a eq ""} {set a "#"}
	
	#----- se il TextGrid è CV, metti tutto in $pronto_cci -----
	if {$tipo($scelto) eq "CV"} {
		set a [string tolower $a]
		if {![string match -nocase "*c*" $a] && ![string match -nocase "*v*" $a] && ![string match -nocase "#" $a]} {
			lappend log [errore_segmento $scelto $n_intervallo $item]
		} else {
			lappend pronto_cci "$a\t$b"
		}
	}
	
	#----- se il TextGrid è SAMPA, trasforma SAMPA in CV -----
	if {$tipo($scelto) eq "SAMPA"} {
		if {[string match "*#*" $a]} {
			set a "#"
		} elseif {[string match $var_sost $a]} {
			set a v
		} else {
			set a c
		}
	}

	#----- calcola la durate degli intervalli #, V e C -----
	if {[regexp {^\#+$} $a]} {
		if {($precedente eq "#") || ($precedente eq "null")} {
			append intervallo $a
			set durata [expr $durata + $b]
		} elseif {($precedente eq "v") || ($precedente eq "c")} {
			lappend pronto "$intervallo\t$durata"
			set intervallo $a
			set durata $b
		}
		set precedente "#"
	
	} elseif {[regexp {^[vV]+$} $a]} {
		if {$precedente eq "v" || ($precedente eq "null")} {
			append intervallo $a
			set durata [expr $durata + $b]
		} elseif {($precedente eq "c") || ($precedente eq "#")} {
			lappend pronto "$intervallo\t$durata"
			set intervallo $a
			set durata $b
		}
		set precedente "v"
	
	} elseif {[regexp {^[cC]+$} $a]} {
		if {$precedente eq "c" || ($precedente eq "null")} {
			append intervallo $a
			set durata [expr $durata + $b]
		} elseif {($precedente eq "v") || ($precedente eq "#")} {
			lappend pronto "$intervallo\t$durata"
			set intervallo $a
			set durata $b
		}
		set precedente "c"
	}
}

#----- scrivi l'ultimo intervallo (che è rimasto da scrivere in pronto) -----
lappend pronto "$intervallo\t$durata"

if {$tipo($scelto) eq "SAMPA"} {
	set pronto_cci $pronto
}

# commenta intervalli iniziali/finali o se sono meno di x per unita' inter-pausale
if {$::discardleft > 0} {
	set pronto [discard_initialIntervals $pronto $::discardleft]
	set pronto_cci [discard_initialIntervals $pronto_cci $::discardleft]
}
if {$::discardright > 0} {
	set pronto [discard_finalIntervals $pronto $::discardright]
	set pronto_cci [discard_finalIntervals $pronto_cci $::discardright]
}
set pronto [discard_toofewIntervals $pronto $::minintervals]
set pronto_cci [discard_toofewIntervals $pronto $::minintervals]


#----- scrivi la segmentazione nelle caselle ------
#foreach riga $pronto {
#	.top_tiers.fr.paolo.text insert end $riga\n
#}
foreach riga $pronto {
	if [string match {*[xX]*} $riga] {
		.top_tiers.fr.paolo.text insert end [string map {x c X C} $riga]\n discarded
	} elseif [string match {*[yY]*} $riga] {
		.top_tiers.fr.paolo.text insert end [string map {y v Y V} $riga]\n discarded
	} else {
		.top_tiers.fr.paolo.text insert end $riga\n
	}
}
foreach riga $pronto_cci {
	if [string match {*[xX]*} $riga] {
		.top_tiers.cci.paolo.text insert end [string map {x c X C} $riga]\n discarded
	} elseif [string match {*[yY]*} $riga] {
		.top_tiers.cci.paolo.text insert end [string map {y v Y V} $riga]\n discarded
	} else {
		.top_tiers.cci.paolo.text insert end $riga\n
	}
}
.top_tiers.cci.paolo.text tag configure discarded -foreground grey
.top_tiers.fr.paolo.text tag configure discarded -foreground grey
.top_tiers.fr.button configure -state normal
.top_tiers.cci.button configure -state normal
update

#----- avverti se il tier scelto ha più pause che segmenti -----
if {$pronto == "" | [llength [lsearch -all $pronto "*#*"]] > [llength [lsearch -all $pronto {*[vVcC]*}]]} {
	array set mess1 {
		it "non sembra essere un tier adeguato. Verificare che sia stato effettivamente etichettato come"
		en "does not seem to be adequate. Please make sure it has really been labelled as)"
	}
	array set mess2 {
		it "I risultati relativi a questo tier potrebbero generare errori. Continuare lo stesso?"
		en "Proceeding may generate errors. Do you want to proceed anyway?"
	}
	catch {
		#destroy .top_tiers.inf
		.top_tiers configure -cursor ""
	}
	set decisione [tk_messageBox -parent .top_tiers -type yesno -message "$scelto $mess1($l) $tipo($scelto) ? $mess2($l)"]
	if {$decisione eq no} {.top_tiers.fl.buttons.pulisci invoke; return}
	catch {.top_tiers configure -cursor watch}
}

#----- calcola correlati -----

set Vseg ""
set Cseg ""
set Vint ""
set Cint ""
set pause ""
set correlati ""
set Vrpvi ""
set Vnpvi ""
set Crpvi ""
set Cnpvi ""
set Vintervalli ""
set Vsegmenti ""
set Cintervalli ""
set Csegmenti ""

#----- estrai le liste $Vint $Cint -----
foreach indice [lsearch -all $pronto {*[vV]*}] {
	lappend Vint [lindex [lindex $pronto $indice] 1]
}
foreach indice [lsearch -all $pronto {*[cC]*}] {
	lappend Cint [lindex [lindex $pronto $indice] 1]
}
foreach indice [lsearch -all $pronto {*#*}] {
	lappend pause [lindex [lindex $pronto $indice] 1]
}

#foreach riga $Vint {
#	.top_tiers.fr.paolo.text insert end $riga\n
#}
#foreach riga $Cint {
#	.top_tiers.cci.paolo.text insert end $riga\n
#}
#.top_tiers.fr.button configure -state normal
#.top_tiers.cci.button configure -state normal
#update


#----- estrai l'equivalente per i CCI -----
foreach indice [lsearch -all $pronto_cci {*[vV]*}] {
	lappend Vintervalli [lindex [lindex $pronto_cci $indice] 1]
	lappend Vsegmenti [lindex [lindex $pronto_cci $indice] 0]
}
foreach indice [lsearch -all $pronto_cci {*[cC]*}] {
	lappend Cintervalli [lindex [lindex $pronto_cci $indice] 1]
	lappend Csegmenti [lindex [lindex $pronto_cci $indice] 0]
}

#----- SOMME, MEDIE E CORRELATI -----
set Vsum [sum $Vint]
set Csum [sum $Cint]
set Tsum [expr $Vsum + $Csum]
set Vperc [expr $Vsum / $Tsum * 100]
lappend correlati "intV\t[llength $Vint]"
lappend correlati "intC\t[llength $Cint]"
lappend correlati "pause\t[llength $pause]"
lappend correlati "Vmean\t[mean $Vint]"
lappend correlati "Cmean\t[mean $Cint]"
lappend correlati "Vperc\t$Vperc\t[B_Vperc $pronto]"
foreach {risv risc corr} {Vdev Cdev stdev varcoV varcoC varco Vrpvi Crpvi rpvi Vnpvi Cnpvi npvi} {
	lappend correlati "$risv\t[$corr $Vint]\t[B_corr $corr V $pronto]"
	lappend correlati "$risc\t[$corr $Cint]\t[B_corr $corr C $pronto]"
}
lappend correlati "Vcci\t[cci $Vintervalli $Vsegmenti]\t[B_cci V $pronto_cci]"
lappend correlati "Ccci\t[cci $Cintervalli $Csegmenti]\t[B_cci C $pronto_cci]"

#----- inserisci i dati nella casella -----
.top_tiers.corr.paolo.text insert end "FILE\t[file tail [file rootname $file]]\n[join $correlati \n]\n\n--\n\n"

#----- crea la segmentazione visiva a partire da $pronto -----
segmentazione_grafica $pronto
.top_tiers.draw.ll.f.spin2 configure -command "segmentazione_grafica \"$pronto\""
.top_tiers.draw.ll.fr.spin configure -command "segmentazione_grafica \"$pronto\""
.top_tiers.draw.ll.show configure -command "segmentazione_grafica \"$pronto\""

.top_tiers.corr.button configure -state normal
.top_tiers.fl.buttons.calcola configure -state disabled
.top_tiers.fr.paolo.text configure -state disabled
.top_tiers.cci.paolo.text configure -state disabled
.top_tiers.corr.paolo.text configure -state disabled

#----- crea il log dei correlati B -----
if {$BATCH_IS_RUNNING == 0 & $::EXTRACT_IPUS} {
	if [catch {toplevel .top_tiers.bcorr}] {destroy .top_tiers.bcorr; toplevel .top_tiers.bcorr}
	wm resizable .top_tiers.bcorr 0 0
	array set mess {it "Correlati per ogni IPU" en "Correlates IPU by IPU"}
	wm title .top_tiers.bcorr $mess($l)
	
	#pack [superscrolled text .top_tiers.bcorr.foo.text y -height 25 -width 80] -fill x -expand yes
	#array set mess {it "Salva come CSV file" en "Save as CSV file"}
	#pack [ttk::button .top_tiers.bcorr.btn -text $mess($l) -image gif_salva -compound left] -fill x -expand yes
	#.top_tiers.bcorr.foo.text insert end [extract_Bcorrelates $pronto]
	
	grid [set fr [ttk::frame .top_tiers.bcorr.frame]] -column 1 -row 1
	foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13} {
		pack [listbox $fr.lb$i -height 15 -width 6 -yscrollcommand {setScroll .top_tiers.bcorr.destra.scrbar}] -fill x -expand yes -side left
	}
	grid [set ds [ttk::frame .top_tiers.bcorr.destra]] -column 2 -row 1 -sticky ns
	pack [ttk::scrollbar .top_tiers.bcorr.destra.scrbar -orient vert -command "synchScroll \[winfo children $fr\] yview"] -fill y -expand no -side right
	
	array set mess {it "Salva come CSV file" en "Save as CSV file"}
	grid [ttk::button .top_tiers.bcorr.btn -text $mess($l) -image gif_salva -compound left -command {
		set csvfile [tk_getSaveFile -defaultextension .csv -parent .top_tiers.bcorr]
		if {$csvfile eq ""} {return}
		if ![catch {open $csvfile w} csvfile_fh] {
			puts $csvfile_fh $Bcorr_testo
			close $csvfile_fh
			tk_messageBox -parent .top_tiers.bcorr -message $csvfile
		}
	}] -columnspan 2 -pady 5
	
	set ::Bcorr_testo [extract_Bcorrelates $pronto]
	foreach line [split [extract_Bcorrelates $pronto] "\n"] {
		set line [split $line ","]
		foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13} {
			set val [lindex $line $i]
			if {![string is integer $val] & [string is double $val]} {set val [format "%.2f" $val]}
			.top_tiers.bcorr.frame.lb$i insert end $val
		}
	}

}

catch {
	#destroy .top_tiers.inf
	.top_tiers configure -cursor ""
}

#----- crea toplevel di log -----
if {[llength $log] > 0} {
	global l
	toplevel .top_tiers.log
	array set mess {
		it "Attenzione: si sono verificati alcuni errori che NON hanno impedito il calcolo dei correlati, ma che hanno causato l'eliminazione di alcuni segmenti. Leggere i dettagli:"
		en "Warning: some errors occurred, which did NOT prevent the computation of rhythm metrics, but which caused the elimination of some segments. Please read the details below:"
	}
	pack [message .top_tiers.log.mess -text $mess($l) -width 400]
	pack [superscrolled text .top_tiers.log.f.text y -width 45 -height 10 -wrap word] -fill both -expand true
	foreach item $log {
		.top_tiers.log.f.text insert end $item\n---\n
	}
	array set mess {it Chiudi en Close}
	pack [ttk::button .top_tiers.log.ok -text $mess($l) -image gif_chiudi -compound left -command {destroy .top_tiers.log}] -fill both
}

}



proc scrivi_report {} {
	global l
	global nuovo_nome_tier
	global BATCH_IS_RUNNING
	
	if [winfo exists .report] {
		array set mess {it "È attualmente aperto il report. Se si procede, il report verrà temporanemente chiuso ed eventuali modifiche non salvate nella finestra di visualizzazione verranno perse." en "The report is currently open. If you proceed, the report window will be temporarily closed and any unsaved modification will be lost."}
		if {[tk_messageBox -message $mess($l) -parent .top_tiers -type okcancel] eq "ok"} {
			destroy .report
		} else {
			return
		}
	}
	
	set scritti ""
	set testo [.top_tiers.corr.paolo.text get 1.0 end]
	foreach entrata [split $testo \n] {
		set entrata [split $entrata \t]
		if {[string match FILE* [lindex $entrata 0]]} {set tier [lindex $entrata 1]}
		if {$entrata eq "--"} {lappend arr($tier) "colour\t[shuffle]"; lappend arr($tier) "border\tblack"; lappend arr($tier) "symbol\tc"}
		if {$entrata ne ""} {
			set entrata [join $entrata \t]
			lappend arr($tier) $entrata
		}
	}
	if {$BATCH_IS_RUNNING == 0} {set reportpath [get_report]} else {set reportpath $::reportpath}
	if {$reportpath eq ""} {return}
	foreach tier [array names arr] {
		if {[rreport $tier $reportpath] eq ""} {
			wreport [join $arr($tier) \n] $reportpath
			lappend scritti $tier
		} else {
			array set mess {
				it " è già presente nel report. Specificare un nuovo nome (lasciare in bianco per non aggiungere questo tier al report)."
				en " is already present in the report. Specify new name (leave blank if you do not want to add this tier to the report)."
			}
			array set errormess {it "Il nuovo nome contiene caratteri non validi oppure è già presente nel report." en "The new name either contains invalid characters or is already present in the report."}
			set nuovo_nome_tier [ptk::getString .top_tiers.top $tier$mess($l) $tier $errormess($l) {[rreport $ptk::getString_string $reportpath] eq ""}]
			if {$nuovo_nome_tier ne ""} {
				set arr($nuovo_nome_tier) $arr($tier)
				lset arr($nuovo_nome_tier) 0 "FILE\t$nuovo_nome_tier"
				wreport [join $arr($nuovo_nome_tier) \n] $reportpath
				lappend scritti $nuovo_nome_tier
			}
		}
	}
	if {[llength $scritti] > 0} {
		if {$::BATCH_IS_RUNNING == 0} {
			array set mess {
				it "Completato. Il seguente file è stato aggiunto a "
				en "Completed. The following file has been successfully added to "
			}
			tk_messageBox -parent .top_tiers -message "$mess($l)[string range $reportpath 0 end-4]:\n[join $scritti \n]"
			}
		.top_tiers.corr.button configure -state disabled
		.charts.disegna configure -state normal
		.charts.apri_report configure -state normal
	} else {
		array set mess {it "Completato. Nessun dato è stato aggiunto al report." en "Completed. No data added to report."}
		tk_messageBox -parent .top_tiers -message "$mess($l)"
	}
}

proc errore_segmento {tier n_intervallo item} {
	global l
	switch -glob -- $item {
			*\[* {set item [string map {\\\[ \[} $item]}
			*\]* {set item [string map {\\\] \]} $item]}
			*\{* {set item [string map {\\\{ \{} $item]} 
			*\}* {set item [string map {\\\} \}} $item]}
		}
	array set mess0 {it "Errore in" en "Error in"}
	array set mess1 {it "all'intervallo" en "at interval"}
	array set mess2 {it "Attesi 'c' o 'v'. Il segmento è stato ignorato." en "Expected 'c' or 'v'. Segment has been ignored."}
	return "\n$mess0($l) $tier $mess1($l) $n_intervallo:\n$item.\n$mess2($l)\n"
}

proc segmentazione_grafica {tier} {
	set cnv .top_tiers.draw.frame.canvas
	global Ccol Vcol Xcol spessore segmfont showsegm
	if ![info exists Ccol] {set Ccol red}
	if ![info exists Vcol] {set Vcol blue}
	if ![info exists Xcol] {set Xcol #E7E7E7}
	if ![info exists spessore] {set spessore 4}
	if ![info exists segmfont] {set segmfont [font actual TkDefaultFont]}
	set ypos [$cnv cget -height]
	set xpos 0
	$cnv delete all
	
	set conto 0
	foreach riga $tier {
		
		if {[lindex $riga 1] <= 0} continue
		
		# metti in $partenza la fine della linea precedente e metti in $xpos la fine di questa linea
		set partenza $xpos
		set xpos [expr $xpos + ([lindex $riga 1] / $::proporzione.0)]
		
		# se c'è un int. voc. o cons. crea la linea colorata, se sono pause una riga bianca.
		if [string match {*[vV]*} $riga] {
			$cnv create line $partenza $ypos $xpos $ypos -fill $Vcol -width $spessore -tag v
			if $showsegm {$cnv create text [expr $partenza + ($xpos - $partenza)/2] [expr $ypos - 5] -text [lindex $riga 0] -font $segmfont -tag segm -anchor s}
		}
		if [string match {*[cC]*} $riga] {
			$cnv create line $partenza $ypos $xpos $ypos -fill $Ccol -width $spessore -tag c
			if $showsegm {$cnv create text [expr $partenza + ($xpos - $partenza)/2] [expr $ypos - 5] -text [lindex $riga 0] -font $segmfont -tag segm -anchor s}
		}
		if [string match {*[xXyY]*} $riga] {
			$cnv create line $partenza $ypos $xpos $ypos -fill $Xcol -width $spessore -tag x
			if $showsegm {$cnv create text [expr $partenza + ($xpos - $partenza)/2] [expr $ypos - 5] -text [string map {x c y v} [lindex $riga 0]] -font $segmfont -tag segm -anchor s}
		}
		if [string match {*#*} $riga] {
			$cnv create line $partenza $ypos $xpos $ypos -fill white -width 4 -tag p
		}
		
		# se siamo almeno alla seconda ripetizione crea la riga verticale
		if $conto {$cnv create line $partenza [expr $ypos + 5] $partenza [expr $ypos - 5]}
		incr conto
	}
	$cnv create line $xpos [expr $ypos + 5] $xpos [expr $ypos - 5]
	
	# sposta al centro (il +5 serve a causa delle stanghette)
	set ymin [lindex [$cnv bbox {v || c || p || segm}] 1]
	$cnv move all 0 -[expr $ymin / 2 + 5]
	
	# crea i bindings
	$cnv bind v <ButtonRelease-1> "set Vcol \[ptk::colChange \$Vcol $cnv\]; $cnv itemconfigure v -fill \$Vcol"
	$cnv bind c <ButtonRelease-1> "set Ccol \[ptk::colChange \$Ccol $cnv\]; $cnv itemconfigure c -fill \$Ccol"
	$cnv bind x <ButtonRelease-1> "set Xcol \[ptk::colChange \$Xcol $cnv\]; $cnv itemconfigure x -fill \$Xcol"
	$cnv bind segm <ButtonRelease-1> "set segmfont \[ptk::selectfont $cnv.font segmfont\]; segmentazione_grafica {$tier}"
	$cnv bind {v || c || x || segm} <Enter> "$cnv configure -cursor hand2"
	$cnv bind {v || c || x || segm} <Leave> "$cnv configure -cursor \"\""
	$cnv configure -scrollregion "0 0 $xpos [$cnv cget -height]"
}

proc batch {} {
	global BATCH_IS_RUNNING
	global l
	
	if [winfo exists .top_tiers] {
		array set mess {it "Attenzione: una finestra di segmentazione è già aperta. Procedere? (la finestra verrà chiusa)" en "Warning: a segmentation window is already open. Shall I proceed? (the window will be closed)"}
		if [tk_messageBox -message $mess($l) -parent .top_tiers -type yesno] {destroy .top_tiers} else {return}
	}
	if [catch {toplevel .batch}] {focus .batch; return}
	wm resizable .batch 0 0
	array set mess {it "Info per il batch" en "Batch info"}
	wm title .batch $mess($l)
	focus .batch
	
	array set mess {
		it "Indice del tier da considerare: "
		en "Enter tier index: "
	}
	message .batch.msg1 -text $mess($l) -width 300
	spinbox .batch.tierindex -textvariable batch_tierindex -from 1 -to 100 -width 7
	grid .batch.msg1 .batch.tierindex -pady {10 0}
	
	array set mess {
		it "Tipo di trascrizione: "
		en "Enter type of transcription: "
	}
	message .batch.msg2 -text $mess($l) -width 300
	ttk::combobox .batch.tiertype -textvariable batch_tiertype -values "CV SAMPA" -width 7
	grid .batch.msg2 .batch.tiertype
	.batch.tiertype set CV
	
	array set mess {
		it "NB: i risultati verranno salvati nel report attivo:"
		en "NB: results will be saved in the current report:"
	}
	grid [message .batch.msg3 -text "$mess($l) $::reportpath" -width 300] -pady 10 -columnspan 2
	
	grid [frame .batch.btns] -columnspan 2 -sticky we
	array set mess {it "Annulla" en "Cancel"}
	pack [ttk::button .batch.btns.annulla -text $mess($l) -image gif_chiudi -compound left -command {destroy .batch}] -expand 1 -side left
	array set mess {it "Vai!" en "Go!"}
	pack [ttk::button .batch.btns.ok -text $mess($l) -image gif_giu -compound left -command {set BATCH_IS_RUNNING 1; destroy .batch}] -expand 1 -side left
	
	tkwait window .batch
	if {$BATCH_IS_RUNNING == 0} {return}
	.sx.b.paolo.lista_file selection clear 0 end
	
	for {set sel_tg 0} {$sel_tg < [.sx.b.paolo.lista_file size]} {incr sel_tg} {
		
		# opens segmentation window
		.sx.b.paolo.lista_file see $sel_tg
		.sx.b.paolo.lista_file selection set $sel_tg
		segmenti [.sx.b.paolo.lista_file get $sel_tg]
		
		# sets correct parameters and invokes the buttons to proceed
		if [catch {.top_tiers.fl.check.cb_$::batch_tierindex select}] {
			set mess(it) "ATTENZIONE: ignoro il file [.sx.b.paolo.lista_file get $sel_tg] perché non contiene il tier $::batch_tierindex."
			set mess(en) "WARNING: skipping file [.sx.b.paolo.lista_file get $sel_tg] because it does not contain tier $::batch_tierindex."
			tk_messageBox -message $mess($l) -icon error
		} else {
			.top_tiers.fl.check.om_$::batch_tierindex set $::batch_tiertype
			.top_tiers.fl.buttons.calcola invoke
			.top_tiers.corr.button invoke
		}
		
		# closes segmentation window
		.top_tiers.fl.buttons.chiudi invoke
		.sx.b.paolo.lista_file selection clear $sel_tg
	}
	set BATCH_IS_RUNNING 0
}

proc discard_initialIntervals {cvlist num} {
	set count 0
	set newlist ""
	foreach interval $cvlist {
		if [string match "#" [lindex $interval 0]] {
			set count 0
		} else {
			incr count
			if {$count <= $num} {
				set val [lindex $interval 0]
				set dur [lindex $interval 1]
				set val [string map {c x C X v y V Y} $val]
				set interval $val\t$dur
			}
		}
		lappend newlist $interval
	}
	return $newlist
}

proc discard_finalIntervals {cvlist num} {
	return [lreverse [discard_initialIntervals [lreverse $cvlist] $num]]
}

proc discard_toofewIntervals {cvlist num} {
	set frasi [split_cvlist_into_sentences $cvlist]
	set newlist ""
	foreach frase $frasi {
		if [string match {*#*} $frase] {
			lappend newlist $frase
		} else {
			if {[count_in_cvlist $frase c] < $num} {
				set frase [string map {c x C X} $frase]
			}
			if {[count_in_cvlist $frase v] < $num} {
				set frase [string map {v y V Y} $frase ]
			}
			lappend newlist $frase
		}
	}
	set newlist [join_sentences_into_cvlist $newlist]
	return $newlist
}

proc split_cvlist_into_sentences {cvlist} {
	set frase ""
	set frasi ""
	foreach interval $cvlist {
		if [string match {*#*} $interval] {
			if {$frase > 0} {lappend frasi $frase}
			lappend frasi $interval
			set frase ""
		} else {
			lappend frase $interval
		}
	}
	return $frasi
}

proc join_sentences_into_cvlist {frasi} {
	set newlist ""
	foreach frase $frasi {
		if [string match {*#*} $frase] {
			lappend newlist $frase
		} else {
			foreach intervallo $frase {
				lappend newlist $intervallo
			}
		}
	}
	return $newlist
}

proc count_in_cvlist {cvlist type} {
	set conto 0
	foreach interval $cvlist {
		if [string match "*$type*" $interval] {incr conto}
	}
	return $conto
}
