#!/usr/bin/wish8.5
package provide app-correlatore 2.3.4

if {([catch {package require Tcl 8.4}]) || ([catch {package require Tk 8.4}]) || ([catch {package require Ttk}] && [catch {package require tile}])} {
	pack [message .mess -text "You are running Tcl $tcl_version and Tk $tk_version. Cannot proceed because Tcl/Tk 8.5 is needed. It is also possible to use Tcl/Tk 8.4 but you need to install the tile extension." -width 300]
	pack [button .butt -text Exit -command exit]
	tkwait window .mess
	exit
}

proc bgerror {error} {
	global l
	
	# crea il top
	set top .correlatore_error
	catch {destroy $top}
	toplevel $top
	focus $top
	#grab $top
	array set mess {it errore en error}
	wm title $top $mess($l)
	
	# crea i widget
	array set mess {it "Si e' verificato un errore, ecco i dettagli: " en "En error occurred: here are the details: "}
	pack [ttk::label $top.l -text $mess($l) -image gif_attenzione -compound left] -padx 10 -pady 10
	pack [superscrolled text $top.f.t xy -width 60 -height 15 -wrap none]
	$top.f.t insert end $::errorInfo
	array set mess {it Chiudi en Close}
	pack [ttk::button $top.b -text $mess($l) -image gif_chiudi -compound left -command "destroy $top"]
	
	# metti a posto il cursore
	foreach w [concat . [winfo child .]] {
		catch {$w configure -cursor ""}
	}
	
	# aspetta che venga chiusa la finestra
	tkwait window $top
}

set dir [file dirname [info script]]
foreach file {calcoli grafici varie report} {
	#source [file join $dir $file.tcl]
	set f [open [file join $dir $file.tcl] r]
	fconfigure $f -encoding utf-8
	set cont [read $f]
	close $f
	eval $cont
}

# plib
foreach file [glob [file join $dir plib *.tcl]] {
	source $file
}

# immagini
foreach file [glob [file join $dir icone *.gif]] {
	image create photo gif_[file tail [file rootname $file]] -file $file
}

set versione 2.3.4
array set about "
it {Correlatore $versione (2009-2015)
Paolo Mairano
Laboratorio di Fonetica Sperimentale
Universita' di Torino}
en {Correlatore $versione (2009-2015)
Paolo Mairano
Laboratory of Experimental Phonetics
University of Turin}
"

set configfile [file join ~ .correlatore config]

# cambia gli attributi di alcuni widget
option add *Button.activeBackground white startupFile
option add *Button.borderWidth 1 startupFile
option add *Label.borderWidth 1 startupFile
#option add *Menu.borderWidth 1 startupFile
bind . <Return> {catch {[focus] invoke}}
bind Spinbox <Return> {if {[%W get] eq ""} {%W insert end 0}; eval [%W cget -command]}
bind Spinbox <FocusOut> {if {[%W get] eq ""} {%W insert end 0}; eval [%W cget -command]}

# se è la prima volta che si usa la versione corrente aggiusta i report per compatibilità
if {([rconfigure versione] ne $versione) && ([rconfigure versione] ne "")} {source [file join $dir versioni.tcl]}

#source [file join $dir start.tcl]
set f [open [file join $dir start.tcl] r]
fconfigure $f -encoding utf-8
set cont [read $f]
close $f
eval $cont
