proc disegna {x y} {
global l
global colore
global simbolo
global bordo
global about
global tcl_platform
global XX
global YY
global xbar
global ybar
array unset XX
array unset YY
array unset xbar
array unset ybar

#----- Se esiste già una finestra di grafici non continuare -----
if [winfo exists .configura] {
	array set mess {
		it "È già aperta una finestra con un grafico. Non è possibile aprirne 2 contemporaneamente."
		en "One chart is already open. It is not possible to edit 2 charts at the same time."
	}
	tk_messageBox -message $mess($l) -parent .configura
	return
}

#----- Chiedi quale report utilizzare -----
set reportpath $::reportpath
if {$reportpath eq ""} {report_problem}
if {[catch {open [file join ~ .correlatore report $reportpath] r} f]} {
	cannot read report
	return
}

#----- costruisci una lista dei tiers e gli array colour border symbol XX YY xbar ybar. -----
if {[rconfigure $x] eq "B"} {set xtipo 1} else {set xtipo 0}
if {[rconfigure $y] eq "B"} {set ytipo 1} else {set ytipo 0}
set tiers ""
while {[gets $f riga] >= 0} {
	switch -glob -- $riga {
		"FILE*" {set tier [lindex $riga 1]; lappend tiers $tier}
		"colour*" {set colore($tier) [lindex $riga 1]}
		"border*" {set bordo($tier) [lindex $riga 1]}
		"symbol*" {set simbolo($tier) [lindex $riga 1]}
	}
	if [string match $x* $riga] {set XX($tier) [lindex $riga [expr 1 + $xtipo]]; set xbar($tier) [lindex $riga [expr 3 + $xtipo]]}
	if [string match $y* $riga] {set YY($tier) [lindex $riga [expr 1 + $ytipo]]; set ybar($tier) [lindex $riga [expr 3 + $ytipo]]}
}
close $f

#----- no tiers, no party -----

if {[llength $tiers] == 0} {
	array set mess {it "Il report è vuoto!" en "The report is empty!"}
	tk_messageBox -message $mess($l)
	return
}

#----- Se è già aperta una finestra ritorna -----

if {[catch {toplevel .configura}]} {
	focus .configura
	return
}
wm title .configura "[string range $reportpath 0 end-4] $y/$x"

#----- resetta le variabili che gestiscono i grafici -----
pchart::unsetVars
. configure -cursor watch

global width height
global simbolo
global bordo
global indicatorsize
global check
global legenda bisector bisectorcol bisectorwidth bisectordash bisector_dash
global x_dash xdash y_dash ydash
global nome
global showleg
global lab
global outlinewidth
set cnv .configura.pane.frameds.canvas

#----- calcola i dati -----

foreach {key value} [array get XX] {lappend xval $value}
foreach {key value} [array get YY] {lappend yval $value}
set pchart::xmin [abbassa [expr int ([min $xval] - 2)] 5]
set pchart::xmax [alza [expr round ([max $xval] + 2)] 5]
if {[expr $pchart::xmax - $pchart::xmin] < 40} {set pchart::xspan 5} else {set pchart::xspan 10}
set pchart::ymin [abbassa [expr int ([min $yval] - 2)] 5]
set pchart::ymax [alza [expr round ([max $yval] + 2)] 5]
if {[expr $pchart::ymax - $pchart::ymin] < 40} {set pchart::yspan 5} else {set pchart::yspan 10}

#----- disegna la finestra opzioni -----

# crea panedwindow
#ttk::panedwindow .configura.pane -orient horizontal
#pack .configura.pane -fill both -expand yes
pack [frame .configura.pane] -fill both -expand yes
#set top [frame .configura.pane.framesx]
#.configura.pane add $top
pack [set top [frame .configura.pane.framesx]] -fill both -expand no -side left
#set ds [frame .configura.pane.frameds]
#.configura.pane add $ds
pack [set ds [frame .configura.pane.frameds]] -fill both -expand yes -side left

# crea i tab
pack [ttk::notebook $top.nb] -fill y -expand yes

array set mess {it "Opzioni generali" en "General options"}
set tab1 [ttk::frame $top.nb.generali]
$top.nb add $tab1 -text $mess($l)

array set mess {it "Assi e griglia" en "Axes and ticks"}
set tab3 [ttk::frame $top.nb.assi]
$top.nb add $tab3 -text $mess($l)

array set mess {it Serie en Series}
set tab2 [ttk::frame $top.nb.serie]
$top.nb add $tab2 -text $mess($l)

# tab1 - crea colonne
pack [ttk::frame $tab1.sopra] -side top -fill both -expand yes
set sin [ttk::frame $tab1.sopra.sin]; pack $sin -side left -fill both -expand yes -padx 5
set des [ttk::frame $tab1.sopra.des]; pack $des -side left -fill both -expand yes -padx {0 5}
pack [set sotto [ttk::frame $tab1.sotto]] -fill both -expand yes -side bottom

# tab1::legenda
pack [set leg [ttk::labelframe $des.leg -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $leg n}
array set mess {it "Legenda" en "Legend"}
set legenda 1
ttk::checkbutton $leg.legenda -variable legenda -text $mess($l) -command "abdisab \$legenda $leg.font $leg.col $leg.bg $leg.bd $leg.lspace $leg.lborder $leg.border; grafico"
$des.leg configure -labelwidget $leg.legenda

array set mess {it "Interspazio: " en "Interspace: "}
grid [ttk::label $leg.lspace -text $mess($l)] -columnspan 2
grid [ttk::scale $leg.space -from 1 -to 50 -variable pchart::legendspace -command "grafico"] -columnspan 2
set pchart::legendspace 15

array set mess {it "Seleziona font" en "Select font"}
set pchart::legendfont [font actual TkDefaultFont]
grid [ttk::button $leg.font -text $mess($l) -command {set pchart::legendfont [ptk::selectfont .configura.font pchart::legendfont]; grafico}] -sticky we -columnspan 2

array set mess {it "Colore testo" en "Text colour"}
set pchart::legendfg black
grid [ttk::button $leg.col -text $mess($l) -command {set pchart::legendfg [cambia_colore pchart::legendfg]; grafico}] -sticky we -columnspan 2

array set mess {it "Colore sfondo" en "Background"}
set pchart::legendbg white
grid [ttk::button $leg.bg -text $mess($l) -command {set pchart::legendbg [cambia_colore pchart::legendbg]; grafico}] -sticky we -columnspan 2

array set mess {it "Colore bordo" en "Border colour"}
set pchart::legendbd black
grid [ttk::button $leg.bd -text $mess($l) -command {set pchart::legendbd [cambia_colore pchart::legendbd]; grafico}] -sticky we -columnspan 2

array set mess {it "Pxl bordo" en "Border pxl"}
ttk::label $leg.lborder -text $mess($l)
set pchart::legendborder 1
spinbox $leg.border -from 0 -to 99 -textvariable pchart::legendborder -width 2 -command grafico -validate key -validatecommand {string is integer %P}
grid $leg.lborder $leg.border

abdisab $legenda $leg.font $leg.col $leg.bg $leg.bd $leg.lspace $leg.lborder $leg.border

# tab1::grafico
array set mess {it "Grafico" en "Chart"}
pack [set gra [ttk::labelframe $sin.gra -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $gra n}

array set mess {it "Larghezza: pxl " en "Width: pxl "}
grid [ptk::labelscale $gra.scalex $mess($l) 1 -from 200 -to 700 -variable width -command "pchart::resize \$width \$height; set trash"]
set width 450

array set mess {it "Altezza: pxl " en "Height: pxl "}
grid [ptk::labelscale $gra.scaley $mess($l) 1 -from 200 -to 700 -variable height -command "pchart::resize \$width \$height; set trash"]
set height 450

array set mess {it "Adatta larghezza" en "Adapt width"}
set pchart::adaptwidth 1
grid [ttk::checkbutton $gra.adatta -variable pchart::adaptwidth -text $mess($l) -command "grafico"] -sticky we -columnspan 2

array set mess {it "Adatta altezza" en "Adapt height"}
set pchart::adaptheight 1
grid [ttk::checkbutton $gra.adattalung -variable pchart::adaptheight -text $mess($l) -command "grafico"] -sticky we -columnspan 2

array set mess {it "Colore sfondo" en "Background colour"}
set pchart::bg white
grid [ttk::button $gra.sfondo -text $mess($l) -command "set pchart::bg \[cambia_colore pchart::bg\]; grafico"] -sticky we

array set mess {it "Colore contorno" en "Contour colour"}
set pchart::contour white
grid [ttk::button $gra.contorno -text $mess($l) -command "set pchart::contour \[cambia_colore pchart::contour\]; grafico"] -sticky we

grid [ttk::frame $gra.tit] -sticky ew
array set mess {it "Titolo:" en "Title:"}
pack [ttk::label $gra.tit.ltit -text $mess($l)] -side left
pack [ttk::entry $gra.tit.tit -width 8 -textvariable pchart::title] -side left -fill x -expand yes
set pchart::title ""
bind $gra.tit.tit <KeyRelease> "abdisab \$pchart::title $gra.font $gra.col; grafico"

array set mess {it "Font titolo" en "Title font"}
set pchart::titlefont [font actual TkDefaultFont]
grid [ttk::button $gra.font -text $mess($l) -command "set pchart::titlefont \[ptk::selectfont .configura.font pchart::titlefont\]; grafico"] -columnspan 2 -sticky we

array set mess {it "Colore titolo" en "Title colour"}
set pchart::titlecol black
grid [ttk::button $gra.col -text $mess($l) -command "set pchart::titlecol \[cambia_colore pchart::titlecol\]; grafico"] -columnspan 2 -sticky we

abdisab $pchart::title $gra.font $gra.col

# tab1::bisettrice
pack [set bis [ttk::labelframe $sin.bis -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $bis n}
array set mess {it "Bisettrice" en "Bisector"}
set ::bisector 0
ttk::checkbutton $bis.show -variable bisector -text $mess($l) -command "abdisab \$bisector $bis.bisectorcol $bis.lwidth $bis.width $bis.dash $bis.tipo; grafico"
$sin.bis config -labelwidget $bis.show

array set mess {it "Colore bisettrice" en "Bisector colour"}
set ::bisectorcol black
grid [ttk::button $bis.bisectorcol -text $mess($l) -command "set bisectorcol \[cambia_colore bisectorcol\]; grafico"] -columnspan 2 -sticky we

array set mess {it Spessore: en Width:}
ttk::label $bis.lwidth -text $mess($l)
set bisectorwidth 1
spinbox $bis.width -from 0 -to 99 -textvariable bisectorwidth -width 2 -command "grafico" -validate key -validatecommand {string is integer %P}
grid $bis.lwidth $bis.width

array set mess {it Tratt.: en Dash:}
set ::bisector_dash 0
ttk::checkbutton $bis.dash -text $mess($l) -variable bisector_dash -command "grafico"
set bisectordash .
ttk::button $bis.tipo -text "..." -width 3 -command "set bisectordash \[chooseDash \$bisectordash\]; grafico"
grid $bis.dash $bis.tipo

abdisab $::bisector $bis.bisectorcol $bis.lwidth $bis.width $bis.dash $bis.tipo

# tab1::etichette
pack [set labe [ttk::labelframe $des.labe -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $labe n}
array set mess {it "Etichette" en "Labels"}
set ::alllab no
ttk::checkbutton $labe.show -text $mess($l) -variable alllab -command "
	abdisab \$alllab $labe.font $labe.col $labe.bg $labe.bd $labe.lborder $labe.border
	foreach tier \[array names lab\] {set lab(\$tier) \$alllab}
	grafico"
$des.labe config -labelwidget $labe.show

array set mess {it "Seleziona font" en "Select font"}
set pchart::labfont [font actual TkDefaultFont]
grid [ttk::button $labe.font -text $mess($l) -command {set pchart::labfont [ptk::selectfont .configura.font pchart::labfont]; grafico}] -columnspan 2 -sticky ew

array set mess {it "Colore testo" en "Foreground"}
grid [ttk::button $labe.col -text $mess($l) -command {set pchart::labfg [cambia_colore pchart::labfg]; grafico}] -columnspan 2 -sticky ew
set pchart::labfg black

array set mess {it "Colore sfondo" en "Background"}
grid [ttk::button $labe.bg -text $mess($l) -command {set pchart::labbg [cambia_colore pchart::labbg]; grafico}] -columnspan 2 -sticky ew
set pchart::labbg white

array set mess {it "Colore bordo" en "Border colour"}
grid [ttk::button $labe.bd -text $mess($l) -command {set pchart::labbd [cambia_colore pchart::labbd]; grafico}] -columnspan 2 -sticky ew
set pchart::labbd black

array set mess {it "Pxl bordo" en "Border pxl"}
ttk::label $labe.lborder -text $mess($l)
set pchart::labborder 1
spinbox $labe.border -from 0 -to 9 -textvariable pchart::labborder -command "grafico" -width 2 -validate key -validatecommand {string is integer %P}
grid $labe.lborder $labe.border

abdisab 0 $labe.font $labe.col $labe.bg $labe.bd $labe.lborder $labe.border

# tab1::logo
pack [label $sotto.logo1 -image gif_lfsag] -fill both -expand yes
pack [label $sotto.logo2 -text $about($l)] -fill both -expand yes

# tab3: crea colonne
pack [set sopra [ttk::frame $tab3.sopra]] -fill both -expand yes
pack [set sin [ttk::frame $sopra.sin]] -side left -fill both -expand yes -padx 5
pack [set des [ttk::frame $sopra.des]] -side left -fill both -expand yes -padx {0 5}

# tab3::asse x
array set mess {it "Asse delle x" en "X axis"}
pack [set assex [ttk::labelframe $sin.assex -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $assex n}

array set mess {it "Etichetta:" en "Label:"}
ttk::label $assex.lex -text $mess($l)
ttk::entry $assex.ex -width 6 -textvariable pchart::xlabel
set pchart::xlabel $x
bind $assex.ex <KeyRelease> "grafico"
grid $assex.lex $assex.ex

ttk::label $assex.lxmin -text Min:
spinbox $assex.xmin -from 0 -to $pchart::xmax -textvariable pchart::xmin -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P < $::pchart::xmax)}
grid $assex.lxmin $assex.xmin

ttk::label $assex.lxmax -text Max:
spinbox $assex.xmax -from $pchart::xmin -to [expr $width - 100] -textvariable pchart::xmax -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P > $::pchart::xmin)}
grid $assex.lxmax $assex.xmax

ttk::label $assex.lxspan -text Span:
spinbox $assex.xspan -from 1 -to 100 -textvariable pchart::xspan -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P > 0)}
grid $assex.lxspan $assex.xspan

array set mess {it Spessore: en Width:}
ttk::label $assex.lxwidth -text $mess($l)
spinbox $assex.xwidth -from 0 -to 99 -textvariable pchart::xaxiswidth -width 4 -command "grafico" -validate key -validatecommand {string is integer %P}
set pchart::xaxiswidth 1
grid $assex.lxwidth $assex.xwidth

array set mess {it "Colore asse" en "Axis colour"}
set pchart::xaxiscol black
grid [ttk::button $assex.colour -text $mess($l) -command "set pchart::xaxiscol \[cambia_colore pchart::xaxiscol\]; grafico"] -columnspan 2 -sticky we

set pchart::xtickcol black
array set mess {it "Colore numeri" en "Number colour"}
grid [ttk::button $assex.ncol -text $mess($l) -command "set pchart::xtickcol \[cambia_colore pchart::xtickcol\]; grafico"] -columnspan 2 -sticky we

set pchart::xtickfont [font actual TkDefaultFont]
array set mess {it "Font numeri" en "Number font"}
grid [ttk::button $assex.nfont -text $mess($l) -command "set pchart::xtickfont \[ptk::selectfont $assex.fo pchart::xtickfont\]; grafico"] -columnspan 2 -sticky we

set pchart::xlabelcol black
array set mess {it "Colore etichette" en "Label colour"}
grid [ttk::button $assex.lcol -text $mess($l) -command "set pchart::xlabelcol \[cambia_colore pchart::xlabelcol\]; grafico"] -columnspan 2 -sticky we

set pchart::xlabelfont [font actual TkDefaultFont]
array set mess {it "Font etichette" en "Label font"}
grid [ttk::button $assex.lfont -text $mess($l) -command "set pchart::xlabelfont \[ptk::selectfont $assex.fo pchart::xlabelfont\]; grafico"] -columnspan 2 -sticky we

# tab3::griglia x
grid [set grigliax [ttk::frame $assex.grigliax]] -columnspan 2 -sticky we -pady {5 0}
if {$::tk_version > 8.4} {grid anchor $grigliax n}

array set mess {it "Mostra griglia" en "Show ticklines"}
set pchart::xticklines 0
grid [ttk::checkbutton $grigliax.mostra -text $mess($l) -variable pchart::xticklines -command "abdisab \$pchart::xticklines $grigliax.xtickcol $grigliax.lwidth $grigliax.width $grigliax.xdash $grigliax.tipo; grafico"] -columnspan 2

array set mess {it "Colore griglia" en "Tickline colour"}
set pchart::xticklinecol grey
grid [ttk::button $grigliax.xtickcol -text $mess($l) -command "set pchart::xticklinecol \[cambia_colore pchart::xticklinecol\]; grafico"] -columnspan 2 -sticky we

array set mess {it Spessore: en Width:}
ttk::label $grigliax.lwidth -text $mess($l)
spinbox $grigliax.width -from 1 -to 99 -textvariable pchart::xticklinewidth -width 3 -command "grafico" -validate key -validatecommand {string is integer %P}
grid $grigliax.lwidth $grigliax.width

array set mess {it Tratt.: en Dash:}
set x_dash 0
ttk::checkbutton $grigliax.xdash -text $mess($l) -variable x_dash -command "grafico"
set xdash .
ttk::button $grigliax.tipo -text "..." -width 3 -command "set xdash \[chooseDash \$xdash\]; grafico"
grid $grigliax.xdash $grigliax.tipo

abdisab $pchart::xticklines $grigliax.xtickcol $grigliax.lwidth $grigliax.width $grigliax.xdash $grigliax.tipo

# tab3::asse y
array set mess {it "Asse delle y" en "Y axis"}
pack [set assey [ttk::labelframe $des.assey -text $mess($l) -labelanchor n]] -pady 5 -fill both
if {$::tk_version > 8.4} {grid anchor $assey n}

array set mess {it "Etichetta:" en "Label:"}
ttk::label $assey.ley -text $mess($l)
ttk::entry $assey.ey -width 6 -textvariable pchart::ylabel
set pchart::ylabel $y
bind $assey.ey <KeyRelease> "grafico"
grid $assey.ley $assey.ey

ttk::label $assey.lymin -text Min:
spinbox $assey.ymin -from 0 -to $pchart::ymax -textvariable pchart::ymin -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P < $::pchart::ymax)}
grid $assey.lymin $assey.ymin

ttk::label $assey.lymax -text Max:
spinbox $assey.ymax -from $pchart::ymin -to [expr $height - 100] -textvariable pchart::ymax -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P > $::pchart::ymin)}
grid $assey.lymax $assey.ymax

ttk::label $assey.lyspan -text Span:
spinbox $assey.yspan -from 1 -to 100 -textvariable pchart::yspan -width 4 -command "grafico" -validate key -validatecommand {expr [string is double %P] && (%P > 0)}
grid $assey.lyspan $assey.yspan

array set mess {it Spessore: en Width:}
ttk::label $assey.lywidth -text $mess($l)
spinbox $assey.ywidth -from 0 -to 99 -textvariable pchart::yaxiswidth -width 4 -command "grafico" -validate key -validatecommand {string is integer %P}
set pchart::yaxiswidth 1
grid $assey.lywidth $assey.ywidth

array set mess {it "Colore asse" en "Axis colour"}
set pchart::yaxiscol black
grid [ttk::button $assey.colour -text $mess($l) -command "set pchart::yaxiscol \[cambia_colore pchart::yaxiscol\]; grafico"] -columnspan 2 -sticky we

set pchart::ytickcol black
array set mess {it "Colore numeri" en "Number colour"}
grid [ttk::button $assey.ncol -text $mess($l) -command "set pchart::ytickcol \[cambia_colore pchart::ytickcol\]; grafico"] -columnspan 2 -sticky we

set pchart::ytickfont [font actual TkDefaultFont]
array set mess {it "Font numeri" en "Number font"}
grid [ttk::button $assey.nfont -text $mess($l) -command "set pchart::ytickfont \[ptk::selectfont $assey.fo pchart::ytickfont\]; grafico"] -columnspan 2 -sticky we

set pchart::ylabelcol black
array set mess {it "Colore etichette" en "Label colour"}
grid [ttk::button $assey.lcol -text $mess($l) -command "set pchart::ylabelcol \[cambia_colore pchart::ylabelcol\]; grafico"] -columnspan 2 -sticky we

set pchart::ylabelfont [font actual TkDefaultFont]
array set mess {it "Font etichette" en "Label font"}
grid [ttk::button $assey.lfont -text $mess($l) -command "set pchart::ylabelfont \[ptk::selectfont $assey.fo pchart::ylabelfont\]; grafico"] -columnspan 2 -sticky we

# tab3::griglia y
grid [set grigliay [ttk::frame $assey.grigliax]] -columnspan 2 -sticky we -pady {5 0}
if {$::tk_version > 8.4} {grid anchor $grigliay n}

array set mess {it "Mostra griglia" en "Show ticklines"}
set pchart::yticklines 0
grid [ttk::checkbutton $grigliay.mostra -text $mess($l) -variable pchart::yticklines -command "abdisab \$pchart::yticklines $grigliay.ytickcol $grigliay.lwidth $grigliay.width $grigliay.ydash $grigliay.tipo; grafico"] -columnspan 2

array set mess {it "Colore griglia" en "Tickline colour"}
set pchart::yticklinecol grey
grid [ttk::button $grigliay.ytickcol -text $mess($l) -command "set pchart::yticklinecol \[cambia_colore pchart::yticklinecol\]; grafico"] -columnspan 2 -sticky we

array set mess {it Spessore: en Width:}
ttk::label $grigliay.lwidth -text $mess($l)
spinbox $grigliay.width -from 1 -to 99 -textvariable pchart::yticklinewidth -width 3 -command "grafico" -validate key -validatecommand {string is integer %P}
grid $grigliay.lwidth $grigliay.width

array set mess {it Tratt.: en Dash:}
set y_dash 0
ttk::checkbutton $grigliay.ydash -text $mess($l) -variable y_dash -command "grafico"
set ydash .
ttk::button $grigliay.tipo -text "..." -width 3 -command "set ydash \[chooseDash \$ydash\]; grafico"
grid $grigliay.ydash $grigliay.tipo

abdisab $pchart::yticklines $grigliay.ytickcol $grigliay.lwidth $grigliay.width $grigliay.ydash $grigliay.tipo

# tab3::margini verticali
array set mess {it "Margini" en "Offset"}
pack [set mar [ttk::labelframe $tab3.mar -text $mess($l) -labelanchor n]] -padx 5 -pady 5 -ipadx 5 -fill both
if {$::tk_version > 8.4} {grid anchor $mar n}
grid columnconfigure $mar 1 -weight 2

array set mess {it "% Nord: " en "North % "}
grid [ptk::labelscale $mar.sn $mess($l)  1 -from 0 -to 50 -variable pchart::noffsetperc -command "grafico"] -columnspan 3
set pchart::noffsetperc 10

array set mess {it "% Ovest: " en "West % "}
grid [ptk::labelscale $mar.sw $mess($l) 1 -from 0 -to 50 -variable pchart::woffsetperc -command "grafico"] -row 1 -column 0 -padx 5
set pchart::woffsetperc 10

array set mess {it "% Est: " en "East % "}
grid [ptk::labelscale $mar.se $mess($l) 1 -from 0 -to 50 -variable pchart::eoffsetperc -command "grafico"] -row 1 -column 2 -padx 5
set pchart::eoffsetperc 10

array set mess {it "% Sud: " en "South % "}
grid [ptk::labelscale $mar.ss $mess($l) 1 -from 0 -to 50 -variable pchart::soffsetperc -command "grafico"] -columnspan 3
set pchart::soffsetperc 10

# crea la parte destra della panedwindow
pack [ttk::frame $ds.toolbar] -fill x -anchor n
array set mess {it "Salva come immagine..." en "Save as image..."}
pack [ptk::btnSaveAsImg $ds.toolbar.img $ds.canvas -text $mess($l) -image gif_disegna -compound left] -fill both -side left -expand yes
array set mess {it "Aggiorna" en "Update"}
pack [ttk::button $ds.toolbar.tklib -text $mess($l) -command "grafico" -image gif_aggiorna -compound left] -side left -fill both -expand yes
#array set mess {it "Salva per dopo" en "Save for later"}
#pack [ttk::button $ds.toolbar.salva -text $mess($l) -image gif_salva -compound top -command salvaperdopo] -fill both -side left -expand yes
#array set mess {it "Apri grafico" en "Open chart"}
#pack [ttk::button $ds.toolbar.apri -text $mess($l) -image gif_cartella -compound top -command "aprigrafico $ds"] -fill both -side left -expand yes
array set mess {it "Esporta in R" en "Export to R (alpha)"}
pack [ttk::button $ds.toolbar.r -text $mess($l) -image gif_cartella -compound left -command "exportR"] -fill both -side left -expand yes
array set mess {it "Chiudi" en "Close"}
pack [ttk::button $ds.toolbar.chiudi -text $mess($l) -command "destroy .configura" -image gif_chiudi -compound left] -side left -fill both -expand yes

# tab 2: serie
pack [ptk::scrolledframe $tab2.frame.canvas.frame y] -expand yes -fill y -pady 2
set lista $tab2.frame.canvas.frame
if {$::tk_version > 8.4} {grid anchor $lista n}
if {$tcl_platform(platform) eq "windows"} {set btnwidth 3} else {set btnwidth 1}

foreach tier [lsort -dictionary $tiers] {
	# frame
	grid [set lf [frame $lista.l$tier -relief raised -border 1]] -sticky news -ipady 5 -ipadx 4
	bind $lf <Enter> "si_freccia $tier"
	bind $lf <Leave> "no_freccia $tier"
	if {$::tk_version > 8.4} {grid anchor $lf center}
	
	# entry -> nome + checkbutton -> mostra + menubutton .> simbolo
	grid [ttk::frame $lf.frm] -columnspan 3 -sticky news
	pack [ttk::checkbutton $lf.frm.check -variable check($tier) -command "eval abdisab \$check($tier) \[winfo child $lf\]; if \$check($tier) {$lf config -relief raised} else {$lf config -relief sunken}; grafico"] -side left
	set nome($tier) $tier
	pack [ttk::entry $lf.frm.entry -textvariable nome($tier) -width 10] -side left -expand yes -fill both
	bind $lf.frm.entry <KeyRelease> "grafico"
	set check($tier) 1
	if ![info exists simbolo($tier)] {set simbolo($tier) c}
	ttk::menubutton $lf.menu -menu $lf.menu.menu
	menu $lf.menu.menu -tearoff 0
	$lf.menu.menu add command -image gif_circle -command "set simbolo($tier) c; grafico; mreport $tier symbol c $reportpath"
	$lf.menu.menu add command -image gif_square -command "set simbolo($tier) s; grafico; mreport $tier symbol s $reportpath"
	$lf.menu.menu add command -image gif_diamond -command "set simbolo($tier) d; grafico; mreport $tier symbol d $reportpath"
	$lf.menu.menu add command -image gif_tup -command "set simbolo($tier) tu; grafico; mreport $tier symbol tu $reportpath"
	$lf.menu.menu add command -image gif_tdown -command "set simbolo($tier) td; grafico; mreport $tier symbol td $reportpath"
	$lf.menu.menu add command -image gif_tleft -command "set simbolo($tier) tl; grafico; mreport $tier symbol tl $reportpath"
	$lf.menu.menu add command -image gif_tright -command "set simbolo($tier) tr; grafico; mreport $tier symbol tr $reportpath"
	$lf.menu.menu add command -image gif_plus -command "set simbolo($tier) +; grafico; mreport $tier symbol + $reportpath"
	$lf.menu.menu add command -image gif_cross -command "set simbolo($tier) x; grafico; mreport $tier symbol x $reportpath"
	$lf.menu.menu add command -image gif_star -command "set simbolo($tier) *; grafico; mreport $tier symbol * $reportpath"
	grid $lf.menu -row 0 -column 3
	
	# checkbutton -> legenda
	array set mess {it "Mostra in legenda" en "Show in legend"}
	set showleg($tier) 1
	grid [ttk::checkbutton $lf.leg -variable showleg($tier) -command "grafico" -text $mess($l)] -columnspan 4
	
	# checkbutton -> etichetta
	array set mess {it "Mostra etichetta" en "Show label"}
	set lab($tier) 0
	grid [ttk::checkbutton $lf.lab -variable lab($tier) -command {grafico} -text $mess($l)] -columnspan 4
	
	# spinbox -> indicatorize
	array set mess {it Dimensione: en Size:}
	ttk::label $lf.lsize -text $mess($l)
	if ![info exists indicatorsize($tier)] {set indicatorsize($tier) 4}
	spinbox $lf.size -from 1 -to 100 -textvariable indicatorsize($tier) -command "grafico" -width 3 -validate key -validatecommand {string is integer %P}
	
	# btn -> colore
	array set mess {it "Colore:" en "Colour:"}
	ttk::label $lf.lcol -text $mess($l)
	if ![info exists colore($tier)] {set colore($tier) [shuffle]}
	button $lf.col -background $colore($tier) -width $btnwidth -command "set colore($tier) \[cambia_colore colore($tier)\]; $lf.col configure -background \$colore($tier); grafico; mreport $tier colour \$colore($tier) $reportpath"
	
	# btn -> bordo
	array set mess {it "Bordo:" en "Border:"}
	ttk::label $lf.lborder -text $mess($l)
	if ![info exists bordo($tier)] {set bordo($tier) black}
	button $lf.border -background $bordo($tier) -width $btnwidth -command "set bordo($tier) \[cambia_colore bordo($tier)\]; $lf.border configure -background \$bordo($tier); grafico; mreport $tier border \$bordo($tier) $reportpath"
	
	# spinbox -> outlinewidth
	array set mess {it Spessore: en Width:}
	ttk::label $lf.lwidth -text $mess($l)
	if ![info exists outlinewidth($tier)] {set outlinewidth($tier) 1}
	spinbox $lf.width -from 0 -to 10 -textvariable outlinewidth($tier) -command "grafico" -width 3 -validate key -validatecommand {string is integer %P}
	
	grid $lf.lcol $lf.col $lf.lsize $lf.size
	grid $lf.lborder $lf.border $lf.lwidth $lf.width
	
	# spinbox -> x values
	ttk::label $lf.lxval -text x:
	spinbox $lf.xval -textvariable XX($tier) -width 4 -from 0 -to 1000 -increment 0.1 -command grafico -validate key -validatecommand {string is double %P}
	
	# spinbox -> xbar
	array set mess {it "barra x:" en "x bar:"}
	if {$xbar($tier) eq ""} {set xbar($tier) 0}
	ttk::label $lf.lxbar -text $mess($l)
	spinbox $lf.xbar -textvariable xbar($tier) -width 4 -from 0 -to 1000 -increment 0.1 -command grafico -validate key -validatecommand {string is double %P}
	
	# spinbox -> x values
	ttk::label $lf.lyval -text y:
	spinbox $lf.yval -textvariable YY($tier) -width 4 -from 0 -to 1000 -increment 0.1 -command grafico -validate key -validatecommand {string is double %P}
	
	# spinbox -> ybar
	array set mess {it "barra y:" en "y bar:"}
	if {$ybar($tier) eq ""} {set ybar($tier) 0}
	ttk::label $lf.lybar -text $mess($l)
	spinbox $lf.ybar -textvariable ybar($tier) -width 4 -from 0 -to 1000 -increment 0.1 -command grafico -validate key -validatecommand {string is double %P}
	
	grid $lf.lxval $lf.xval $lf.lxbar $lf.xbar
	grid $lf.lyval $lf.yval $lf.lybar $lf.ybar
}


# frame
set tier una_combinazione_improbabile_affinche_non_possa_confondersi_con_il_vero_nome_di_un_item_uaau_wddw
grid [set lf [frame $lista.l$tier -relief raised -border 1]] -sticky news
if {$::tk_version > 8.4} {grid anchor $lf center}

#message con spiegazioni
array set mess {
	it "Attenzione: questo riquadro controlla le impostazioni di tutte le serie ed è fornito per comodità; le modifiche verranno applicate a tutte le serie."
	en "Warning: this frame controls all series and is only provided as a commodity; any modification will be applied to all series."
}
grid [message $lf.mess -text $mess($l) -width 220 -justify center] -columnspan 4

# entry -> nome + checkbutton -> mostra
array set mess {it "Mostra tutti/nessuno" en "Show all/none"}
grid [ttk::checkbutton $lf.check -variable all_check -text $mess($l) -command "
	foreach tier \[array names check\] {
		set check(\$tier) \$all_check
		eval abdisab \$all_check \[winfo child $lista.l\$tier\]
		if \$all_check {$lista.l\$tier config -relief raised} else {$lista.l\$tier config -relief sunken}
	}
	grafico
"] -columnspan 4

# checkbutton -> legenda
array set mess {it "Mostra in legenda" en "Show in legend"}
grid [ttk::checkbutton $lf.leg -variable all_showleg -text $mess($l) -command {
	foreach tier [array names showleg] {
		set showleg($tier) $all_showleg
	}
	grafico
}] -columnspan 4

# checkbutton -> etichetta
array set mess {it "Mostra etichetta" en "Show label"}
grid [ttk::checkbutton $lf.lab -variable all_lab -text $mess($l) -command {
	foreach tier [array names lab] {
		set lab($tier) $all_lab
	}
	grafico
}] -columnspan 4

# menubutton -> simbolo
array set mess {it "Indicatore" en "Indicator"}
ttk::label $lf.simb -text $mess($l)
#set all_simbolo c
ttk::menubutton $lf.menu -menu $lf.menu.menu -text $mess($l)
menu $lf.menu.menu -tearoff 0
$lf.menu.menu add command -image gif_circle -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) c; mreport \$tier symbol c $reportpath}; grafico"
$lf.menu.menu add command -image gif_square -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) s; mreport \$tier symbol s $reportpath}; grafico"
$lf.menu.menu add command -image gif_diamond -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) d; mreport \$tier symbol d $reportpath}; grafico"
$lf.menu.menu add command -image gif_tup -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) tu; mreport \$tier symbol tu $reportpath}; grafico"
$lf.menu.menu add command -image gif_tdown -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) td; mreport \$tier symbol td $reportpath}; grafico"
$lf.menu.menu add command -image gif_tleft -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) tl; mreport \$tier symbol tl $reportpath}; grafico"
$lf.menu.menu add command -image gif_tright -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) tr; mreport \$tier symbol tr $reportpath}; grafico"
$lf.menu.menu add command -image gif_plus -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) +; mreport \$tier symbol + $reportpath}; grafico"
$lf.menu.menu add command -image gif_cross -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) x; mreport \$tier symbol x $reportpath}; grafico"
$lf.menu.menu add command -image gif_star -command "foreach tier \[array names simbolo\] {set simbolo(\$tier) *; mreport \$tier symbol * $reportpath}; grafico"

# spinbox -> indicatorize
array set mess {it Dimensione: en Size:}
ttk::label $lf.lsize -text $mess($l)
set ::all_indicatorsize 4
spinbox $lf.size -from 1 -to 100 -textvariable all_indicatorsize -width 3 -validate key -validatecommand {string is integer %P} -command {
	foreach tier [array names indicatorsize] {
		set indicatorsize($tier) $all_indicatorsize
	}
	grafico
}

# spinbox -> outlinewidth
array set mess {it Spessore: en Width:}
ttk::label $lf.lwidth -text $mess($l)
set ::all_outlinewidth 1
spinbox $lf.width -from 0 -to 10 -textvariable all_outlinewidth -width 3 -validate key -validatecommand {string is integer %P} -command {
	foreach tier [array names outlinewidth] {
		set outlinewidth($tier) $all_outlinewidth
	}
	grafico
}

# btn -> colore
array set mess {it "Colore" en "Colour"}
ttk::button $lf.col -text $mess($l) -command "
	set all_col \[cambia_colore all_col\]
	foreach tier \[array names colore\] {
		set colore(\$tier) \$all_col
		$lista.l\$tier.col configure -background \$colore(\$tier)
		mreport \$tier colour \$colore(\$tier) $reportpath
	}
	grafico
"

# btn -> bordo
array set mess {it "Bordo" en "Border"}
ttk::button $lf.border -text $mess($l) -command "
	set all_bordo \[cambia_colore all_bordo\]
	foreach tier \[array names bordo\] {
		set bordo(\$tier) \$all_bordo
		$lista.l\$tier.border configure -background \$bordo(\$tier)
		mreport \$tier border \$bordo(\$tier) $reportpath
	}
	grafico
"

grid $lf.menu -columnspan 4
grid $lf.col $lf.lwidth $lf.width
grid $lf.border $lf.lsize $lf.size


$tab2.frame.canvas configure -width 250

# disegna il grafico
grafico

# fai tornare normale il cursore del mouse
. configure -cursor ""

}

proc grafico {{ds .configura.pane.frameds} args} {
	global l
	global width height
	global simbolo
	global indicatorsize
	global colore
	global bordo
	global check
	global legenda bisector bisectorcol bisectorwidth bisectordash bisector_dash
	global x_dash xdash y_dash ydash
	global nome
	global showleg
	global lab
	global outlinewidth
	global XX
	global YY
	global xbar
	global ybar
	set ds .configura.pane.frameds
	
	#controlla che 2 serie non abbiano lo stesso nome
	set lista_nomi [concat [array_values nome]]
	foreach item $lista_nomi {
		if {[string_count $lista_nomi $item] > 1} {
			array set mess {it "Impossibile procedere: a 2 serie è stato attribuito lo stesso nome:" en "Cannot proceed: the same name has been attributed to 2 series:"}
			tk_messageBox -message "$mess($l) $item" -parent .configura
			return
		}
	}
	
	
	if {$x_dash == 0} {set dashx ""} {set dashx $xdash}
	if {$y_dash == 0} {set dashy ""} {set dashy $ydash}
	catch {destroy $ds.canvas}
	
	#1) disegna grafico
	pack [pchart::draw $ds.canvas -width $width -height $height -xdash $dashx -ydash $dashy] -pady 5 -padx 5 -anchor center -expand yes
	
	#2)inserisci bisettrice
	if $bisector {
		if $bisector_dash {set dashbisector $bisectordash} {set dashbisector ""}
		pchart::insertLine 1 0 -fill $bisectorcol -width $bisectorwidth -dash $dashbisector
	}
	
	#3)inserisci i dati per ogni serie
	#set indicatorsize [approssima $indicatorsize 1]
	set lista ".configura.pane.framesx.nb.serie.frame.canvas.frame"
	foreach tier [lsort -dictionary [array names XX]] {
		if {$check($tier) == 0} {continue}
		
		switch -- $simbolo($tier) {
			"c" {$lista.l$tier.menu configure -image gif_circle}
			"s" {$lista.l$tier.menu configure -image gif_square}
			"d" {$lista.l$tier.menu configure -image gif_diamond}
			"tu" {$lista.l$tier.menu configure -image gif_tup}
			"td" {$lista.l$tier.menu configure -image gif_tdown}
			"tl" {$lista.l$tier.menu configure -image gif_tleft}
			"tr" {$lista.l$tier.menu configure -image gif_tright}
			"+" {$lista.l$tier.menu configure -image gif_plus}
			"x" {$lista.l$tier.menu configure -image gif_cross}
			"*" {$lista.l$tier.menu configure -image gif_star}
		}
		
		pchart::insertSeries $nome($tier) "$XX($tier) $YY($tier)" \
			-fill $colore($tier) -outline $bordo($tier) -shape $simbolo($tier) -size $indicatorsize($tier) -width $outlinewidth($tier)\
			-showlab $lab($tier) -showinleg $showleg($tier) \
			-xbar "$xbar($tier) -$xbar($tier)" -ybar "$ybar($tier) -$ybar($tier)"
	}
	
	#4) inserisci etichette
	pchart::insertLabels
		
	#5) inserisci legenda
	if {$legenda == 1} {pchart::insertLegend}
	
}

proc abbassa {valore {differenza 10}} {
	for {set conto 0} {$conto <= $differenza} {incr conto} {
		if {fmod ($valore, $differenza)} {set valore [expr $valore - 1]} else {return $valore}
	}
}

proc alza {valore {differenza 10}} {
	for {set conto 0} {$conto <= $differenza} {incr conto} {
		if {fmod ($valore, $differenza)} {set valore [expr $valore + 1]} else {return $valore}
	}
}

proc random {{colori {aquamarine bisque black blue blueViolet brown cadetBlue chartreuse chocolate coral cyan DarkBlue DarkCyan DarkGreen DarkGrey DarkOrchid DarkSlateGrey DeepSkyBlue forestGreen gold goldenRod green grey khaki lawnGreen LightBlue magenta mediumBlue navy orange orangeRed orchid pink purple red salmon slateBlue slateGrey thistle violet yellow white}}} {
	set n [llength $colori]
	set r [expr int(rand()*$n)]
	set colore [lindex $colori $r]
}

proc shuffle {} {
	set c1 [format %1X [expr int(rand()*16)]]
	set c2 [format %1X [expr int(rand()*16)]]
	set c3 [format %1X [expr int(rand()*16)]]
	return "#$c1$c1$c2$c2$c3$c3"
}

proc escludi {colore} {
	set colori {aquamarine bisque black blue blueViolet brown cadetBlue chartreuse chocolate coral cyan DarkBlue DarkCyan DarkGreen DarkGrey DarkOrchid DarkSlateGrey DeepSkyBlue forestGreen gold goldenRod green grey khaki lawnGreen LightBlue magenta mediumBlue navy orange orangeRed orchid pink purple red salmon slateBlue slateGrey thistle violet yellow white}
	set n [llength $colori]
	set r [expr int(rand()*$n)]
	set colore [lindex $colori $r]
	set colori [lreplace $colori $r $r]
}

proc cambia_colore {var} {
	upvar #0 $var col
	set colore [tk_chooseColor -parent .configura]
	if {$colore ne ""} {return $colore} {return $col}
}

proc chooseDash {current} {
	if [catch {set top [toplevel .configura.dash]}] {focus .configura.dash}
	global l dashes
	set dashes $current
	array set mess {it "Scegliere la configurazione delle linee." en "Choose line pattern."}
	pack [ttk::label $top.label -text $mess($l)] -pady 10
	pack [ttk::frame $top.valori]
	set i 0
	foreach {a b} {. ..... - "- - -" .- ". - ."} {
		pack [ttk::button $top.valori.s$i -text $b -command "set dashes $a; $top.canvas itemconfigure line -dash \$dashes"] -side left -padx {5 10}
		incr i
	}
	pack [canvas $top.canvas -height 50 -width 200]
	$top.canvas create line 0 25 200 25 -dash $dashes -tag line
	pack [ttk::button $top.ok -text "Ok" -command "destroy $top"]
	tkwait window $top.ok
	return $dashes
}

proc si_freccia {tier} {
	global XX
	global YY
	global nome
	catch {destroy .configura.pane.frameds.canvas.tip}
	set x [pchart::x $XX($tier)]
	set y [pchart::y $YY($tier)]
	set xcord [format "%.2f" $XX($tier)]
	set ycord [format "%.2f" $YY($tier)]
	place [label .configura.pane.frameds.canvas.tip -text "$nome($tier)\n($xcord:$ycord)" -anchor w -bg white -relief solid] -x [expr $x + 7] -y $y -anchor w
}

proc no_freccia {tier} {
	destroy .configura.pane.frameds.canvas.tip
	.configura.pane.frameds.canvas delete tip
}

proc exportR {} {
	global XX
	global YY
	global colore
	global bordo
	global simbolo
	global l
	
	if {[catch {
		set f [open [set filename [tk_getSaveFile -defaultextension .R -parent .configura]] w]
		puts $f "x <- c([join [array_values XX] ,])"
		puts $f "y <- c([join [array_values YY] ,])"
		puts $f "names <- c('[join [array names XX] "' ,'"]')"
		puts $f "plot (x, y, type='n', xlab='$::pchart::xlabel', ylab='$::pchart::ylabel', main='$::pchart::title')"
		foreach tier [array names XX] {
			set pchs($tier) [get_pch $simbolo($tier)]
			if {$pchs($tier) < 21} {
				set cols($tier) $colore($tier)
				set bgs($tier) black
			} else {
				set cols($tier) $bordo($tier)
				set bgs($tier) $colore($tier)
			}
		}
		puts $f "pchs <- c([join [array_values pchs] ,])"
		puts $f "cols <- c('[join [array_values cols] "', '"]')"
		puts $f "bgs <- c('[join [array_values bgs] "', '"]')"
		puts $f "points (x, y, bg=bgs, col=cols, pch=pchs)"
		puts $f "legend ('topright', legend=names, pch=pchs, col=cols, pt.bg=bgs)"
		
		close $f
		array set mess {it "Dati salvati in" en "Data saved to"}
	} error]} {
			bgerror $error
			array set mess {it "Si è verificato un errore nell'esportazione." en "An error has occurred while exporting."
		}
	}
	tk_messageBox -parent .configura -message "$mess($l) $filename"
}

proc get_pch {simbolo} {
	array set pch {c 21 s 22 d 23 tu 24 td 25 tl 24 tr 25 \+ 3 x 4 \* 8}
	return $pch($simbolo)
}

proc cambia_simbolo {tier simbolo reportpath} {
	set ::simbolo($tier) $simbolo
	mreport $tier symbol $simbolo $reportpath
	grafico
}

#proc controlla {} {
	#global width legenda indicatorsize
	#global XX
	#set lunghezza 0
	#foreach tier [array names XX] {
		#if {[font measure font $tier] > $lunghezza} {set lunghezza [font measure font $tier]}
	#}
	#if {$legenda == 1} {set width [expr $width + $lunghezza + ($indicatorsize * 10)]}
	#if {$legenda == 0} {set width [expr $width - $lunghezza - ($indicatorsize * 10)]}
#}

# proc salvaperdopo {} {
	# global l
	# set file [tk_getSaveFile -defaultextension .tcl]
	# if [catch {set f [open $file w]}] {cannot write $file; return}
	# foreach var {width height titlefont titlecol legenda legendspace legendfont legendcol legendbg legendbd legendborder adaptwidth sfondo contorno indicatorsize xnumcol ynumcol xnumfont ynumfont xlabelcol ylabelcol xlabelfont ylabelfont ex ey xmin ymin xmax ymax xspan yspan xaxiswidth yaxiswidth xaxiscol yaxiscol xtick xtickcol ytick ytickcol xticklinewidth x_dash xdash yticklinewidth y_dash ydash} {
		# global $var
		# puts $f "global $var"
		# if {[set $var] eq ""} {puts $f "set $var \"\""} else {puts $f "set $var \"[set $var]\""}
	# }
	# foreach var {simbolo colore bordo check XX YY} {
		# global $var
		# puts $f "global $var"
		# puts $f "array set $var {"
		# foreach {key value} [array get $var] {
			# puts $f "$key $value"
		# }
		# puts $f "}"
	# }
	# close $f
	# array set mess {it "Grafico salvato in " en "Chart has been saved in "}
	# tk_messageBox -parent .configura -message $mess($l)$file
# }

# proc aprigrafico {ds} {
	# global l
	# set file [tk_getOpenFile]
	# global simbolo colore check XX YY
	# array unset simbolo
	# array unset colore
	# array unset bordo
	# array unset check
	# array unset XX
	# array unset YY
	# source $file
	# if [catch {source $file}] {cannot read $file; return}
	
	# #set figli [winfo children .configura.pane.framesx.nb.serie.win]
	# #foreach figlio $figli {destroy $figlio}
	# destroy .configura.pane.framesx.nb.serie.win
	
	# set tab2 .configura.pane.framesx.nb.serie
	# set scrwin [ScrolledWindow $tab2.win]
	# set scrfrm [ScrollableFrame $scrwin.frm -width 0]
	# $scrwin setwidget $scrfrm
	# pack $scrwin -expand yes -fill both
	# grid $scrfrm
	# set lista [$scrfrm getframe]
	# grid anchor $lista n
	# label $lista.l0 -text ""
	# array set mess {it Nome en Name}
	# label $lista.l1 -text $mess($l)
	# array set mess {it Simbolo en Symbol}
	# label $lista.l2 -text $mess($l)
	# array set mess {it Colore en Fill}
	# label $lista.l3 -text $mess($l)
	# array set mess {it Bordo en Outline}
	# label $lista.l4 -text $mess($l)
	# grid $lista.l0 $lista.l1 $lista.l2 $lista.l3 $lista.l4 -pady 5 -padx 5
	
	# foreach tier [lsort -dictionary [array names simbolo]] {
		# checkbutton $lista.check$tier -variable check($tier) -command "grafico"
		# $lista.check$tier select
		# label $lista.opt0_$tier -text $tier
		# bind $lista.opt0_$tier <Enter> "si_freccia $tier"
		# bind $lista.opt0_$tier <Leave> "no_freccia $tier"
		# set simbolo($tier) c
		# ttk::menubutton $lista.menu$tier -menu $lista.menu$tier.menu
		# menu $lista.menu$tier.menu -tearoff 0
		# $lista.menu$tier.menu add command -image gif_circle -command "set simbolo($tier) c; grafico"
		# $lista.menu$tier.menu add command -image gif_square -command "set simbolo($tier) s; grafico"
		# $lista.menu$tier.menu add command -image gif_diamond -command "set simbolo($tier) d; grafico"
		# $lista.menu$tier.menu add command -image gif_tup -command "set simbolo($tier) tu; grafico"
		# $lista.menu$tier.menu add command -image gif_tdown -command "set simbolo($tier) td; grafico"
		# $lista.menu$tier.menu add command -image gif_tleft -command "set simbolo($tier) tl; grafico"
		# $lista.menu$tier.menu add command -image gif_tright -command "set simbolo($tier) tr; grafico"
		# $lista.menu$tier.menu add command -image gif_plus -command "set simbolo($tier) +; grafico"
		# $lista.menu$tier.menu add command -image gif_cross -command "set simbolo($tier) x; grafico"
		# $lista.menu$tier.menu add command -image gif_star -command "set simbolo($tier) *; grafico"
		# #set colore($tier) [shuffle]
		# #set bordo($tier) black
		# button $lista.opt2_$tier -background $colore($tier) -width 1 -command "set colore($tier) \[cambia_colore colore($tier)\]; $lista.opt2_$tier configure -background \$colore($tier); grafico"
		# button $lista.opt3_$tier -background $bordo($tier) -width 1 -command "set bordo($tier) \[cambia_colore bordo($tier)\]; $lista.opt3_$tier configure -background \$bordo($tier); grafico"
		# grid $lista.check$tier $lista.opt0_$tier $lista.menu$tier $lista.opt2_$tier $lista.opt3_$tier
	# }
	
	# grafico
# }
