# procedure per creare delle forme sul canvas

proc circle {nome x y dim {in white} {out black} {width 0} {tag circle}} {
	$nome create oval [expr $x - $dim] [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] -fill $in -outline $out -tag $tag -width $width
}

proc square {nome x y dim {in white} {out black} {width 0} {tag square}} {
	$nome create rect [expr $x - $dim] [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] -fill $in -outline $out -tag $tag -width $width
}

proc triangleup {nome x y dim {in white} {out black} {width 0} {tag triangleup}} {
	$nome create poly $x [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] [expr $x - $dim] [expr $y + $dim] -fill $in -outline $out -tag $tag -width $width
}

proc triangledown {nome x y dim {in white} {out black} {width 0} {tag triangledown}} {
	$nome create poly $x [expr $y + $dim] [expr $x + $dim] [expr $y - $dim] [expr $x - $dim] [expr $y - $dim] -fill $in -outline $out -tag $tag -width $width
}

proc triangleleft {nome x y dim {in white} {out black} {width 0} {tag triangleleft}} {
	$nome create poly [expr $x - $dim] $y [expr $x + $dim] [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] -fill $in -outline $out -tag $tag -width $width
}

proc triangleright {nome x y dim {in white} {out black} {width 0} {tag triangleright}} {
	$nome create poly [expr $x + $dim] $y [expr $x - $dim] [expr $y - $dim] [expr $x - $dim] [expr $y + $dim] -fill $in -outline $out -tag $tag -width $width
}

proc diamond {nome x y dim {in white} {out black} {width 0} {tag diamond}} {
	$nome create poly [expr $x + $dim] $y $x [expr $y + $dim] [expr $x - $dim] $y $x [expr $y - $dim] -fill $in -outline $out -tag $tag -width $width
}

proc plus {nome x y dim {in black} {width 0} {tag plus}} {
	$nome create line [expr $x + $dim] $y [expr $x - $dim] $y -width 2 -fill $in -width $width -tag $tag
	$nome create line $x [expr $y + $dim] $x [expr $y - $dim] -width 2 -fill $in -width $width -tag $tag
}

proc cross {nome x y dim {in black} {width 0} {tag cross}} {
	$nome create line [expr $x - $dim] [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] -width 2 -fill $in -width $width -tag $tag
	$nome create line [expr $x + $dim] [expr $y - $dim] [expr $x - $dim] [expr $y + $dim] -width 2 -fill $in -width $width -tag $tag
}

proc asterisk {nome x y dim {in black} {width 0} {tag asterisk}} {
	$nome create line [expr $x + $dim] $y [expr $x - $dim] $y -fill $in -width $width -tag $tag
	$nome create line $x [expr $y + $dim] $x [expr $y - $dim] -fill $in -width $width -tag $tag
	$nome create line [expr $x - $dim] [expr $y - $dim] [expr $x + $dim] [expr $y + $dim] -fill $in -width $width -tag $tag
	$nome create line [expr $x + $dim] [expr $y - $dim] [expr $x - $dim] [expr $y + $dim] -fill $in -width $width -tag $tag
}

proc canvastext {canvas x y args} {
	set testo [eval $canvas create text $x $y $args]
	
	.text bind $testo <Button-1> "focus $canvas; $canvas focus $testo; $canvas icursor $testo {@%x,%y}"
	.text bind $testo <KeyPress> "$canvas insert $testo insert %A"
	#.text bind $testo <Left> "$canvas icursor $testo {insert - 1 char}"
	#.text bind $testo <Right> "$canvas icursor $testo {insert + 1 char}"
	.text bind $testo <Home> "$canvas icursor $testo 0"
	.text bind $testo <End> "$canvas icursor $testo end"
	.text bind $testo <Delete> "$canvas dchar $testo insert"
	#.text bind $testo <BackSpace> "$canvas icursor $testo {insert - 1char}"
	
	return $testo
}
