namespace eval phtml {

# visualizza su un text il contenuto di un file di testo con alcuni tag di formattazione, es.: 'parse readme.html .text'
proc parse {text tipo file {font "times 11"} {enc "utf-8"}} {
	$text configure -font $font
	
	#leggi il file e riempi il text
	if {$tipo eq "file"} {
		set f [open $file r]
		fconfigure $f -encoding $enc
		set contenuto [read $f]
		close $f
	} elseif {$tipo eq "var"} {
		set contenuto [concat $file]
	}
	
	# crea un array con le entities più frequenti
	array set ent {
		&aacute; \u00e1
		&eacute; \u00e9
		&iacute; \u00ed
		&oacute; \u00f3
		&uacute; \u00fa
		&Aacute; \u00c1
		&Eacute; \u00c9
		&Iacute; \u00cd
		&Oacute; \u00d3
		&Uacute; \u00da
		&agrave; \u00e0
		&egrave; \u00e8
		&igrave; \u00ec
		&ograve; \u00f2
		&ugrave; \u00f9
		&Agrave; \u00c0
		&Egrave; \u00c8
		&Igrave; \u00cc
		&Ograve; \u00d2
		&Ugrave; \u00d9
		&acirc; \u00e2
		&ecirc; \u00ea
		&icirc; \u00ee
		&ocirc; \u00f4
		&ucirc; \u00fb
		&Acirc; \u00c2
		&Ecirc; \u00ca
		&Icirc; \u00ce
		&Ocirc; \u00d4
		&Ucirc; \u00db
		&auml; \u00e4
		&euml; \u00eb
		&iuml; \u00ef
		&ouml; \u00f6
		&uuml; \u00fc
		&Auml; \u00c4
		&Euml; \u00cb
		&Iuml; \u00cf
		&Ouml; \u00d6
		&Uuml; \u00dc
		&amp; &
		&Delta; \u0394
	}
	
	# sostituisci le entities con i valori corrispondenti
	foreach {a b} [array get ent] {
		set contenuto [string map "$a $b" $contenuto]
	}
	
	#lavora con i tag
	set conto 0
	set write 1
	set writetag 0
	set prec ""
	foreach char [split $contenuto ""] {
		
		# se apre un tag
		if {$char eq "<"} {
			set write 0
			set writetag 1
			set tag ""
		}
		
		if $write {
			regsub {\s} $char " " char
			if {[regexp {\s} $prec] && [regexp {\s} $char]} {} else {$text insert end $char}
			set prec $char
			incr conto
		} else {
			if {$char eq " "} {set writetag 0}
			if $writetag {lappend tag $char}
		}
		
		# se chiude un tag
		if {$char eq ">"} {
			set tag [join $tag ""]
			if {[string index $tag 1] ne "/"} {
				set tag [string map {< "" > ""} $tag]
				$text mark set $tag insert
				$text mark gravity $tag left
			} else {
				set tag [string map {< "" > ""} $tag]
				$text tag add $tag [string range $tag 1 end] current
			}
			if [regexp {^.?(p|br|h|li)} $tag] {$text insert end \n}
			if {$tag eq "li"} {$text insert end " - "}
			set write 1
			set writetag 0
		}
		
	}
	
	#configura i tag standard
	$text tag configure all -font $font -justify left -foreground black
	$text tag configure /h1 -font "[lindex $font 0] 20 bold" -justify center -foreground blue
	$text tag configure /h2 -font "[lindex $font 0] 16 bold" -justify center -foreground blue
	$text tag configure /h3 -font "[lindex $font 0] 12 normal" -justify left -foreground blue
	$text tag configure /b -font "[lindex $font 0] [lindex $font 1] bold"
	$text tag configure /i -font "[lindex $font 0] [lindex $font 1] italic"
	$text tag configure /u -font "[lindex $font 0] [lindex $font 1] underline"
	$text tag configure /center -justify center
}
}
