global tcl_platform
global reportpath dir
global versione
global l
global BATCH_IS_RUNNING
global discardleft
global discardright
global minintervals
set BATCH_IS_RUNNING 0

#window option
wm resizable . 0 0
wm title . Correlatore
focus -force .

#lingua
set showinstructions 0
if {[set l [rconfigure lingua]] eq ""} {
	
	#scelta lingua
	pack [ttk::frame .inizio]
	grid [label .inizio.l -image gif_lfsag -compound bottom -text "$about(it)\n" -anchor n] -columnspan 3 -pady 15
	grid [label .inizio.l2 -text "Welcome! Please choose your language.\nBenvenuti! Per favore scegliere la lingua." -anchor n] -columnspan 3 -pady {0 20}
	ttk::button .inizio.exit -text Exit -command exit -image gif_chiudi -compound left
	ttk::button .inizio.en -text English -command {destroy .inizio; set l en} -image gif_en -compound left
	ttk::button .inizio.it -text Italiano -command {destroy .inizio; set l it} -image gif_it -compound left
	grid .inizio.exit .inizio.en .inizio.it
	tkwait window .inizio
	
	#accettazione licenza
	grid [ttk::frame .licenza]
	array set inizio {
		en "Welcome! This seems to be the first time you run Correlatore.\n\nThis programme can be used to compute rhythm correlates from\nPraat TextGrid files. It is recommended that you read the instructions,\npaying particular attention to the annotation criteria\nyou need to follow in order to get the correct results.\n\nIn order to use Correlatore you have to accept the terms of the GPL license:"
		it "Benvenuti! Questa sembra essere la prima volta che eseguite Correlatore.\n\nQuesto programma puo' essere usato per calcolare i\ncorrelati del ritmo a partire da file annotati con Praat (TextGrid).\nSi consiglia di leggere attentamente le istruzioni, con particolare\nattenzione ai criteri di annotazione da usare per ottenere risultati corretti.\n\nPer poter usare Correlatore è necessario accettare i termini della licenza GPL:"
	}
	grid [ttk::label .licenza.l -text $inizio($l)] -columnspan 2 -pady {5 0}
	
	set f [open [file join $dir licenza.txt]]
	set lic [read $f]
	close $f
	grid [superscrolled text .licenza.frame.text y -height 15 -width 72] -columnspan 2 -padx 5
	.licenza.frame.text insert end $lic
	.licenza.frame.text configure -state disabled
	
	array set mess {it "Accetto i termini della licenza GPL" en "I accept the terms of the GPL license"}
	grid [ttk::checkbutton .licenza.c1 -text $mess($l) -variable acceptlicense] -columnspan 2 -pady 10
	set acceptlicense 0
	array set mess {it "Mostra le istruzioni" en "Show me the instructions"}
	grid [ttk::checkbutton .licenza.c2 -text $mess($l) -variable showinstructions] -columnspan 2 -pady {0 15}
	set showinstructions 1
	
	ttk::button .licenza.go -text OK -command {
		if {$acceptlicense != 1} {
			#messaggio: necessario accettare licenza
			array set mess {it "Per proseguire è necessario accettare i termini della licenza." en "You need to accept license terms in order to proceed."}
			tk_messageBox -message $mess($l)
		} else {
			#crea cartelle nascoste e configura versione e lingua
			file mkdir [file join ~ .correlatore]
			file mkdir [file join ~ .correlatore report]
			wconfigure lingua $l
			wconfigure versione $versione
			destroy .licenza
		}
	} -image gif_ok -compound left
	array set mess {it Esci en Exit}
	ttk::button .licenza.exit -text $mess($l) -command exit -image gif_chiudi -compound left
	grid .licenza.exit .licenza.go -pady {5 0}
	
	tkwait window .licenza
}

#varsost
if {[set var_sost [rconfigure var_sost]] eq ""} {
	set var_sost "*\[aeiouyAEIOUYMQV@&1236789={}\]*"
} else {
	set var_sost [string trimright $var_sost]
}

#discardright
if {[set discardright [rconfigure discardright]] eq ""} {
	set discardright 0
} else {
	set discardright [string trimright $discardright]
}

#discardright
if {[set discardleft [rconfigure discardleft]] eq ""} {
	set discardleft 0
} else {
	set discardleft [string trimright $discardleft]
}

#minintervals
if {[set minintervals [rconfigure minintervals]] eq ""} {
	set minintervals 2
} else {
	set minintervals [string trimright $minintervals]
}


#reportpath
if {[set reportpath [rconfigure reportpath]] eq ""} {
	set reportpath standard.txt
} else {
	set reportpath [string trimright $reportpath]
}

#barra di stato
grid [ttk::frame .stato] -row 3 -column 1 -columnspan 2 -sticky we
pack [ttk::frame .stato.segmopt] -anchor w -fill both
array set mess {it "Elimina intervalli iniziali: " en "Discard initial intervals: "}
pack [ttk::label .stato.segmopt.labinit -text $mess($l)] -side left -fill both -padx {10 0}
pack [spinbox .stato.segmopt.init -from 0 -to 10 -width 3 -textvariable discardleft -command {wconfigure discardleft $discardleft}] -side left -fill both -padx {0 10}
array set mess {it "Elimina intervalli finali: " en "Discard final intervals: "}
pack [ttk::label .stato.segmopt.labfinal -text $mess($l)] -side left -fill both -padx {10 0}
pack [spinbox .stato.segmopt.final -from 0 -to 10 -width 3 -textvariable discardright -command {wconfigure discardright $discardright}] -side left -fill both -padx {0 10}
array set mess {it "Min. di intervalli per frase: " en "Min intervals per sentence: "}
pack [ttk::label .stato.segmopt.labmin -text $mess($l)] -side left -fill both -padx {10 0}
pack [spinbox .stato.segmopt.min -from 2 -to 10 -width 3 -textvariable minintervals -command {wconfigure minintervals $minintervals}] -side left -fill both -padx {0 10}

array set mess {it "Variabile di sostituzione SAMPA =" en "SAMPA substitution variable ="}
pack [ttk::button .stato.varsost -command cambia_var_sost -text "$mess($l) [string range $var_sost 2 end-2]"] -anchor s -fill both -pady {7 0}

#menu
. configure -menu .menubar; menu .menubar

array set mess {it File en File}
.menubar add cascade -label $mess($l) -menu .menubar.file; menu .menubar.file -tearoff 0
array set mess {it "Apri un file TextGrid" en "Open TextGrid"}
.menubar.file add command -label $mess($l) -command apri -image gif_piu -compound left
array set mess {it "Apri cartella" en "Open folder"}
.menubar.file add command -label $mess($l) -command apricartella -image gif_trova -compound left
array set mess {it "Chiudi file selezionato" en "Close selected file"}
.menubar.file add command -label $mess($l) -command chiudi -image gif_meno -compound left
array set mess {it "Chiudi tutti i file" en "Close all files"}
.menubar.file add command -label $mess($l) -command azzera -image gif_stop -compound left
.menubar.file add separator
array set mess {it "Importa una lista di valori e calcola correlati" en "Import a list of values and compute correlates"}
.menubar.file add command -label $mess($l) -command {importa} -image gif_var -compound left
.menubar.file add separator
array set mess {it Esci en Quit}
.menubar.file add command -label $mess($l) -command {exit} -image gif_esci -compound left

array set mess {it Modifica en Edit}
.menubar add cascade -label $mess($l) -menu .menubar.modifica; menu .menubar.modifica -tearoff 0
array set mess {it "Modifica variabile di sostituzione" en "Edit substitution variable"}
.menubar.modifica add command -label $mess($l) -command cambia_var_sost -image gif_pref -compound left
array set mess {it "Modifica preferenze correlati" en "Edit preferences for rhythm metrics"}
.menubar.modifica add command -label $mess($l) -command cambia_modo -image gif_pref -compound left
array set mess {it "Cambia report attivo" en "Change active report"}
.menubar.modifica add command -label $mess($l) -command get_report -image gif_pref -compound left
.menubar.modifica add separator
array set mess {it "Visualizza implementazione TCL dei correlati" en "View TCL implementation of rhythm metrics"}
.menubar.modifica add command -label $mess($l) -command funzioni -image gif_formule -compound left

array set mess {it Visualizza en View}
.menubar add cascade -label $mess($l) -menu .menubar.visualizza; menu .menubar.visualizza -tearoff 0
array set mess {it "Barra degli strumenti" en "Toolbar"}
.menubar.visualizza add check -variable barra -label $mess($l) -command {
	if {$barra == 0} {
		grid forget .barra; wconfigure barra 0
	} else {
		grid .barra -row 1 -column 1 -columnspan 2 -sticky we; wconfigure barra 1
	}
}
array set mess {it "Barra di stato" en "Statusbar"}
.menubar.visualizza add check -variable stato -label $mess($l) -command {
	if {$stato == 0} {
		grid forget .stato; wconfigure stato 0
	} else {
		grid .stato -row 3 -column 1 -columnspan 2 -sticky we; wconfigure stato 1
	}
}
array set mess {it "Suggerimenti" en "Tooltips"}
.menubar.visualizza add check -variable tips -label $mess($l) -command {wconfigure tips $tips; ricomincia}

array set mess {it Azioni en Actions}
.menubar add cascade -label $mess($l) -menu .menubar.azioni; menu .menubar.azioni -tearoff 0
array set mess {it "Segmenta e calcola correlati" en "Segment and compute rhythm metrics"}
.menubar.azioni add command -label $mess($l) -command {.sx.b.segmenti invoke} -image gif_giu -compound left
array set mess {it "Disegna grafico" en "Draw chart"}
.menubar.azioni add command -label $mess($l) -command {disegna $X $Y} -image gif_disegna -compound left
array set mess {it "Gestisci report" en "Open report"}
.menubar.azioni add command -label $mess($l) -command apri_report -image gif_report -compound left

array set mess {it Lingua en Language}
.menubar add cascade -label $mess($l) -menu .menubar.lingua; menu .menubar.lingua -tearoff 0
.menubar.lingua add radio -label "English" -variable l -value en -command "cambia_l en"
.menubar.lingua add radio -label "Italiano" -variable l -value it -command "cambia_l it"

array set mess {it Aiuto en Help}
.menubar add cascade -label $mess($l) -menu .menubar.aiuto; menu .menubar.aiuto -tearoff 0
array set mess {it About en About}
.menubar.aiuto add command -label $mess($l) -command {tk_messageBox -message $about($l) -icon info} -image gif_domanda -compound left
array set mess {it Aiuto en Help}
.menubar.aiuto add command -label $mess($l) -command aiuto -image gif_aiuto -compound left
array set mess {it "Vai al sito web" en "Visit website"}
.menubar.aiuto add command -label $mess($l) -image gif_web -compound left -command {
	if {$tcl_platform(platform) eq "windows"} {
		eval exec [auto_execok start] {http://www.lfsag.unito.it/correlatore/} &
	} else {
		if [catch {http://www.lfsag.unito.it/correlatore/}] {
			foreach browser {firefox opera safari galeon epiphany konqueror} {
				if ![catch {exec $browser http://www.lfsag.unito.it/correlatore/ &}] {return}
				array set mess {it "Non ho trovato il browser." en "Browser not detected."}
				tk_messageBox -mess $mess($l)
			}
		}
	}
}

#tema
if {$tcl_platform(platform) eq "unix"} {
	source [file join $dir unix.tcl]
}

#barra degli strumenti
grid [ttk::frame .barra] -row 1 -column 1 -columnspan 2 -sticky we
array set mess {it "Importa" en "Import"}
ttk::button .barra.importa -text $mess($l) -command importa -image gif_var -compound top
array set mess {it "Formule" en "Formulas"}
ttk::button .barra.formule -text $mess($l) -command funzioni -image gif_formule -compound top
array set mess {it "Correlati" en "Metrics"}
ttk::button .barra.correlati -command cambia_modo -text $mess($l) -image gif_pref -compound top
ttk::button .barra.en -text English -command "cambia_l en" -image gif_en -compound top
ttk::button .barra.it -text Italiano -command "cambia_l it" -image gif_it -compound top
array set mess {it "Aiuto" en "Help"}
ttk::button .barra.aiuto -text $mess($l) -command aiuto -image gif_aiuto -compound top
array set mess {it "Esci" en "Quit"}
ttk::button .barra.esci -text $mess($l) -image gif_esci -compound top -command exit
grid .barra.importa .barra.formule .barra.correlati .barra.en .barra.it .barra.aiuto .barra.esci -sticky news
grid columnconfigure .barra "0 1 2 3 4 5 6" -weight 1 -uniform group1

#parte sinistra
grid [ttk::labelframe .sx -text Textgrids:] -row 2 -column 1 -padx {10 5} -pady 10 -sticky ns
pack [ttk::frame .sx.a] -side left -padx {10 5} -pady 5
array set mess {it "Apri cartella" en "Open folder"}
grid [ttk::button .sx.a.scan -text $mess($l) -command apricartella -image gif_trova -compound top] -sticky news
array set mess {it "Apri file" en "Open file"}
grid [ttk::button .sx.a.apri -text $mess($l) -command apri -image gif_piu -compound top] -sticky news
array set mess {it "Chiudi file" en "Close file"}
grid [ttk::button .sx.a.chiudi -text $mess($l) -command chiudi -image gif_meno -compound top] -sticky news
array set mess {it "Chiudi tutti" en "Close all"}
grid [ttk::button .sx.a.azzera -text $mess($l) -command azzera -image gif_stop -compound top] -sticky news
array set mess {it "Codifica" en "Encoding"}
grid [ttk::label .sx.a.lab -text $mess($l)] -pady {10 0}
set chosen_enc [encoding system]
grid [ttk::combobox .sx.a.enc -textvariable chosen_enc -values [encoding names] -width 10]
pack [ttk::frame .sx.b] -side left -padx {0 10} -pady 5
pack [superscrolled listbox .sx.b.paolo.lista_file xy -width 45 -height 10 -selectmode single] -fill x
bind .sx.b.paolo.lista_file <<ListboxSelect>> {abdisab_segm}
array set mess {it "Segmenta e calcola correlati" en "Segmentation and rhythm metrics"}
pack [ttk::button .sx.b.segmenti -text $mess($l) -state disabled -command {
		if {[.sx.b.paolo.lista_file size] == 0} {
			array set mess {it "Prima è necessario apire uno o piu' file TextGrid." en "You need to open one o more TextGrids first."}
			tk_messageBox -message $mess($l)
		} elseif {[.sx.b.paolo.lista_file curselection] eq ""} {
			array set mess {it "Prima è necessario selezionare un file." en "First you need to select a file."}
			tk_messageBox -message $mess($l)
		} elseif {[llength [.sx.b.paolo.lista_file curselection]] > 1} {
			array set mess {it "Piu' di un file sono selezionati. È possibile segmentare un solo file per volta. Deselezionarli tutti tranne uno."	en "More than one file are selected. Only one file at a time can be processed. Deselect all but one."}
			tk_messageBox -message $mess($l)
		} else {segmenti [.sx.b.paolo.lista_file get [.sx.b.paolo.lista_file curselection]]}
} -image gif_giu -compound left] -fill x
array set mess {it "Processa tutti i file in batch" en "Process all files in a batch"}
pack [ttk::button .sx.b.batch -text $mess($l) -state disabled -command {
		if {[.sx.b.paolo.lista_file size] == 0} {
			array set mess {it "Prima è necessario apire uno o piu' file TextGrid." en "You need to open one o more TextGrids first."}
			tk_messageBox -message $mess($l)
		} else {
			batch
		}
} -image gif_giu -compound left] -fill x

#parte destra
grid [ttk::labelframe .charts -text Report:] -row 2 -column 2 -padx {5 10} -pady 10 -sticky ns
grid [ttk::combobox .charts.active -textvariable reportpath -width 10 -values [report_names]] -pady {5 0}
bind .charts.active <<ComboboxSelected>> {wconfigure reportpath $reportpath}
grid [button .charts.more -image gif_star -command get_report] -row 0 -column 1 -pady {5 0}
array set mess {it "Gestisci report" en "Open report"}
grid [ttk::button .charts.apri_report -text $mess($l) -command apri_report -image gif_report -compound top] -sticky we -padx 10 -pady 10 -columnspan 2
array set mess {it "Asse delle X:" en "X axis:"}
grid [ttk::label .charts.labx -text $mess($l)] -padx 10 -columnspan 2
ttk::combobox .charts.optx -textvariable X -values {Vperc Vdev Cdev varcoV varcoC Vrpvi Crpvi Vnpvi Cnpvi Vcci Ccci} -width 8
grid .charts.optx -padx 10 -columnspan 2
set X Vdev
array set mess {it "Asse delle Y:" en "Y axis:"}
grid [ttk::label .charts.laby -text $mess($l)] -padx 10 -pady {10 0} -columnspan 2
ttk::combobox .charts.opty -textvariable Y -values {Vperc Vdev Cdev varcoV varcoC Vrpvi Crpvi Vnpvi Cnpvi Vcci Ccci} -width 8
grid .charts.opty -padx 10 -columnspan 2
set Y Cdev
array set mess {it "Disegna grafico" en "Draw chart"}
grid [ttk::button .charts.disegna -text $mess($l) -command {disegna $X $Y} -image gif_disegna -compound top] -sticky we -padx 10 -pady 10 -columnspan 2


# variabili globali barra e stato (servono per i checkbutton del menu) e codifica
global barra
set barra [rconfigure barra]
if {$barra eq ""} {set barra 1}
if {$barra == 0} {grid forget .barra}

global stato
set stato [rconfigure stato]
if {$stato eq ""} {set stato 1}
if {$stato == 0} {grid forget .stato}


# Dynamic Help
global tips
set tips [rconfigure tips]
if {$tips eq ""} {set tips 1}
if {$tips == 1} {
	array set mess {it "Apre tutti i file TextGrid in una determinata cartella" en "Looks for TextGrid files in a folder"}
	suggerimento .sx.a.scan $mess($l)
	array set mess {it "Apre un file TextGrid" en "Opens a TextGrid"}
	suggerimento .sx.a.apri $mess($l)
	array set mess {it "Rimuove il file selezionato dal riquadro sottostante" en "Removes selected file from the listbox below"}
	suggerimento .sx.a.chiudi $mess($l)
	array set mess {it "Rimuove tutti i file dal riquadro sottostante" en "Removes all files from the listbox below"}
	suggerimento .sx.a.azzera $mess($l)
	array set mess {it "Importa valori da file txt e calcola correlati" en "Importa values from a txt file and compute correlates"}
	suggerimento .barra.importa $mess($l)
	array set mess {it "Visualizza implementazione TCL delle formule di nPVIs, rPVIs e CCIs" en "See TCL implementation of nPVI, rPVI and CCI formulas"}
	suggerimento .barra.formule $mess($l)
	suggerimento .barra.en "Switch to English"
	suggerimento .barra.it "Passa all'italiano"
	array set mess {it "Visualizza la Guida" en "See help"}
	suggerimento .barra.aiuto $mess($l)
	array set mess {it "Esci" en "Quit"}
	suggerimento .barra.esci $mess($l)
	array set mess {it "Apre una nuova finestra per la segmentazione e il calcolo dei correlati del file selezionato" en "Opens a new windows for the segmentation and the calculation of rhythm metrics for the files selected"}
	suggerimento .sx.b.segmenti $mess($l)
	array set mess {it "In questo riquadro vengono mostrati i file TextGrid aperti" en "Here you can see the TextGrids currently open"}
	suggerimento .sx.b.paolo.lista_file $mess($l)
	array set mess {it "Visualizza il file di report e consente di effettuare modifiche" en "Shows report and allows you to edit it"}
	suggerimento .charts.apri_report $mess($l)
	array set mess {it "Disegna un grafico a partire dai valori dei correlati contenuti nel file di report; specificare l'asse delle X e delle Y" en "Draws a chart using the values contained in the report; you have to specify X and Y axis"}
	suggerimento .charts.disegna $mess($l)
	array set mess {it "Permette di modificare la variabile di sostituzione, che si occupa di trasformare le trascrizioni SAMPA in CV" en "Click to modify the substitution variable, which establishes how SAMPA transcriptions are transformed into CV sequences"}
	suggerimento .stato.varsost $mess($l)
	array set mess {it "Permette di gestire quali correlati mostrare nei grafici" en "Click to modify which correlates are to be shown on the charts."}
	suggerimento .barra.correlati $mess($l)
	array set mess {it "Permette di cambiare il report attivo" en "Click to change the active report"}
	suggerimento .charts.active $mess($l)
	suggerimento .charts.more $mess($l)
	array set mess {it "Permette di scegliere cosa mostrare sull'asse delle x del grafico." en "Choose the values to be displayed on the x-axis."}
	suggerimento .charts.labx $mess($l)
	array set mess {it "Permette di scegliere cosa mostrare sull'asse delle y del grafico." en "Choose the values to be displayed on the y-axis."}
	suggerimento .charts.laby $mess($l)
	array set mess {it "Permette di seleziona la codifica del TextGrid" en "Specify the TextGrid encoding"}
	suggerimento .sx.a.enc $mess($l)
	array set mess {it "Avvia un batch che processa tutti i TextGrid aperti e salva i risultati nel report attivo" en "Starts a batch that processes all files and saves results in the current report"}
	suggerimento .sx.b.batch $mess($l)
}

# controlla se nella cartella di correlatore ci sono dei TextGrid; in tal caso aggiungili nella listbox
catch {
	foreach file [lsort -dictionary [glob -nocomplain "*.TextGrid"]] {
		if {[lsearch [.sx.b.paolo.lista_file get 0 end] $file] != -1} {continue}
		.sx.b.paolo.lista_file insert end $file
	}
	.sx.b.paolo.lista_file selection set end
	abdisab_segm
}

if {$showinstructions == 1} {aiuto; set showinstructions 0}
