proc cambia_l {new} {
	global l
	if {[wconfigure lingua $new] == 0} {
		return
	} else {
		ricomincia	
	}
}

proc ricomincia {} {
	global dir
	foreach w {.menubar .barra .sx .charts .stato} {
		destroy $w
	}
	source [file join $dir start.tcl]
}

proc aiuto {} {
	global l about dir
	if [winfo exists .top_aiuto] {
		focus .top_aiuto
		return
	}
	set text [ptk::textWithSearch .top_aiuto "" -wrap word -background #B7F876]
	array set mess {it Aiuto en Help}
	wm title .top_aiuto $mess($l)
	
	$text insert end $about($l)\n------\n /center
	phtml::parse $text file [file join $dir $l.html] "times 11 normal"
	$text configure -state disabled
}

proc cambia_var_sost {} {
	global l
	global var_sost
	global nuovo
	set nuovo [string range $var_sost 2 end-2]
	
	if [catch {toplevel .varsost}] {focus .varsost; return}
	wm resizable .varsost 0 0
	array set mess {it "Variabile di sostituzione" en "Substitution variable"}
	wm title .varsost $mess($l)
	
	array set message {
		"it" "Questa variabile determina come vengono riconosciute le trascrizioni SAMPA. Tutti i simboli contenuti in essa verranno considerati vocalici, tutti gli altri consonantici. Se si vuole includere i simboli \- \[ \] è necessario farli precedere da un backslash: \\ . Non è possibile includere #, poiché questo simbolo indica una pausa, né \" poiché indica l'accento.\nAl momento il valore della variabile è il seguente:"
		"en" "This variable determines how SAMPA transcriptions are converted into CV. All symbols contained in it will be considered as vowels, the rest as consonants. If you wish to use one or more of the following symbols \- \[ \], then it is necessary to write them preceded by a backslash: \\ . You can neither include #, as it already indicates pauses, nor \", as it indicates stress.\n At the moment, the variable's value is:"
	}
	grid [message .varsost.message -width 300 -text $message($l)] -row 1 -column 1 -columnspan 3
	grid [ttk::label .varsost.label -text [string range $var_sost 2 end-2] -relief sunken] -row 2 -column 1 -columnspan 3 -pady 10
	array set message {
		"it" "Inserire nuovo valore:"
		"en" "Insert the new value:"
	}
	grid [ttk::label .varsost.label2 -text $message($l)] -row 3 -column 1 -columnspan 3
	grid [ttk::entry .varsost.entry -textvariable nuovo -validate key -validatecommand {expr ![string match # %S] && ![string match \" %S]}] -row 4 -column 1 -columnspan 3 -pady 10 -sticky we
	bind .varsost.entry <Return> {.varsost.ok invoke}
	array set mess {it Salva en Save}
	grid [ttk::button .varsost.ok -text $mess($l) -image gif_salva -compound left -command {
		array set mess1 {it "Attenzione: il carattere" en "Warning: character"}
		array set mess2 {it "deve essere preceduto da un backslash." en "must be preceded by a backslash."}
		switch -regexp -- $nuovo {
			{[^\\]-} {tk_messageBox -parent .varsost -message "$mess1($l) - $mess2($l)"; return}
			{[^\\]\[} {tk_messageBox -parent .varsost -message "$mess1($l) \[ $mess2($l)"; return}
			{[^\\]\]} {tk_messageBox -parent .varsost -message "$mess1($l) \] $mess2($l)"; return}
		}
		set var_sost "*\[$nuovo\]*"
		wconfigure var_sost $var_sost
		.varsost.label configure -text [string range $var_sost 2 end-2]
		array set mess {it "Variabile di sostituzione =" en "Substitution variable ="}
		.stato.varsost configure -text "$mess($l) [string range $var_sost 2 end-2]"
	}] -row 5 -column 3
	array set message {it Ripristina en Reset}
	grid [ttk::button .varsost.ripristina -text $message($l) -image gif_aggiorna -compound left -command {
		set var_sost "*\[aeiouyAEIOUYMQV@&1236789={}\]*"
		set nuovo [string range $var_sost 2 end-2]
		wconfigure var_sost $var_sost
		.varsost.label configure -text [string range $var_sost 2 end-2]
		array set mess {it "Variabile di sostituzione =" en "Substitution variable ="}
		.stato.varsost configure -text "$mess($l) [string range $var_sost 2 end-2]"
	}] -row 5 -column 2
	array set message {it Chiudi en Close}
	grid [ttk::button .varsost.fatto -text $message($l) -image gif_chiudi -compound left -command {destroy .varsost}] -row 5 -column 1
}

proc apri {} {
	set files [tk_getOpenFile -multiple true]
	foreach file $files {.sx.b.paolo.lista_file insert end $file}
	.sx.b.paolo.lista_file selection clear 0 end
	.sx.b.paolo.lista_file selection set end
	abdisab_segm
}

proc chiudi {} {
	set indice [expr [.sx.b.paolo.lista_file curselection] - 1]
	.sx.b.paolo.lista_file delete active
	.sx.b.paolo.lista_file selection set $indice
}

proc azzera {} {
	.sx.b.paolo.lista_file delete 0 end
	abdisab_segm
}

proc funzioni {} {
	global l dir
	
	if [catch {toplevel .top_funzioni}] {focus .top_funzioni; return}
	array set mess {it "Formule" en "Formulas"}
	wm title .top_funzioni $mess($l)
	
	#crea il notebook
	set tab .top_funzioni.nb
	pack [ttk::notebook $tab] -fill both -expand yes
	
	array set bibl {
		stdev "Ramus, F., Nespor, M. &amp; Mehler, J. (1999). Correlates of linguistic rhythm in the speech signal. <i>Cognition</i>, 73/3, 265-292."
		varco "Dellwo, V. (2006). Rhythm and speech rate: A variation coefficient for deltaC. <i>Language and Language Processing: Proceedings of the 38th Linguistic Colloquium</i>, Piliscsaba 2003, ed. by Pawel Karnowski Imre Szigeti, 231–241. Frankfurt: Peter Lang."
		rpvi "Grabe, E. &amp; Low, E.L. (2002). Durational variability in speech and the rhythm class hypothesis. In: Gussenhoven, C., Warner, N. (eds), <i>Papers in Laboratory Phonology</i> 7, Berlin: Mouton de Gruyter, 515-546."
		npvi "Grabe, E. &amp; Low, E.L. (2002). Durational variability in speech and the rhythm class hypothesis. In: Gussenhoven, C., Warner, N. (eds), <i>Papers in Laboratory Phonology</i> 7, Berlin: Mouton de Gruyter, 515-546."
		cci "Bertinetto, P. M. &amp; Bertini, C. (2008). On modeling the rhythm of natural languages. <i>Proc. of the 4<sup>th</sup> International Conference on Speech Prosody</i>, Campinas 2008, 427-430."
	}
	
	foreach corr {stdev varco rpvi npvi cci} {
		#aggiungi il tab
		ttk::frame $tab.$corr
		$tab add $tab.$corr -text $corr
		grid columnconfigure $tab.$corr 1 -weight 1
		grid rowconfigure $tab.$corr 0 -weight 1
		grid rowconfigure $tab.$corr 1 -weight 1
		grid rowconfigure $tab.$corr 2 -weight 1
		
		#crea l'immagine
		catch {image create photo gif_$corr -file [file join $dir icone $corr.gif]}
		grid [ttk::label $tab.$corr.gif -image gif_$corr] -pady 5 -columnspan 3
		
		#crea il text con l'implementazione TCL
		grid [superscrolled text $tab.$corr.f.text y -height 12 -width 80 -wrap word -tabs "25 left"] -columnspan 3 -sticky news
		array set mess1 {it Riferimento en Reference}
		array set mess2 {it "Implementazione Tcl" en "Tcl implementation"}
		phtml::parse $tab.$corr.f.text var "<h3>$mess1($l)</h3>$bibl($corr)<br><h3>$mess2($l)</h3>"
		$tab.$corr.f.text insert end "proc $corr {[info args $corr]} {[info body $corr]}"
		$tab.$corr.f.text delete 1.0 2.0
		$tab.$corr.f.text config -state disabled
		
		#crea un'etichetta che spiega cosa fare
		array set mess {
			it "È possibile inserire dei valori (separati da uno spazio) su cui calcolare la funzione. In alternativa è anche possibile importare i dati da un file TXT in cui i valori siano separati da uno spazio, due punti, punto e virgola, trattino o una combinazioni di questi."
			en "You can insert some values (separated by a space) and try the function on them. Alternately, you can import data from a TXT file (in this case, values can be separated by one or more of the following: a space, a colon, a semi-colon or a dash."
		}
		grid [message $tab.$corr.mess -text $mess($l) -width 500] -pady 5 -columnspan 3
		
		#crea il frame con 1 entry e 1 btn per immetere i dati
		array set mess {it "Valori:" en "Values:"}
		grid [ttk::label $tab.$corr.l1 -text $mess($l)] -row 3 -column 0 -padx 5
		grid [ttk::entry $tab.$corr.entry1 -width 30] -row 3 -column 1 -sticky we
		bind $tab.$corr.entry1 <Return> "$tab.$corr.ok invoke"
		array set mess {it Importa en Import}
		grid [ttk::button $tab.$corr.b1 -image gif_importa -text $mess($l) -compound "left" -command "
			foreach item \[txt2list $tab\] {
				$tab.$corr.entry1 insert end \"\$item \"
			}
		"] -row 3 -column 2 -padx 5
		
		if {$corr ne "cci"} {	
			#crea un btn per calcolare il correlato
			array set mess {it Calcola en Compute}
			grid [ttk::button $tab.$corr.ok -image gif_ok -text $mess($l) -compound "left" -command "
				set values \[$tab.$corr.entry1 get\]
				if {\[llength \$values\] < 2} {
					array set mess {it \"Inserire almeno 2 valori.\" en \"Insert at least 2 values.\"}
					tk_messageBox -parent $tab -message \$mess($l)
				} else {
					tk_messageBox -parent $tab -message \"$corr = \[$corr \$values\]\"
				}
			"] -columnspan 3
		} else {
			#crea il secondo frame con 1 entry e 1 btn per immetere i dati
			array set mess {it "Segmenti:" en "Segments:"}
			grid [ttk::label $tab.$corr.l2 -text $mess($l)] -row 4 -column 0 -padx 5
			grid [ttk::entry $tab.$corr.entry2 -width 30] -row 4 -column 1 -sticky we
			bind $tab.$corr.entry2 <Return> "$tab.$corr.ok invoke"
			array set mess {it Importa en Import}
			grid [ttk::button $tab.$corr.b2 -image gif_importa -text $mess($l) -compound "left" -command "
				foreach item \[txt2list $tab\] {
					$tab.$corr.entry2 insert end \"\$item \"
				}
			"] -row 4 -column 2 -padx 5
			
			#crea un btn per calcolare il correlato
			array set mess {it Calcola en Compute}
			grid [ttk::button $tab.$corr.ok -image gif_ok -text $mess($l) -compound "left" -command "
				set values \[$tab.$corr.entry1 get\]
				set segments \[$tab.$corr.entry2 get\]
				if {\[llength \$values\] != \[llength \$segments\]} {
					array set mess {it \"Attenzione: i valori e i segmenti non corrispondono.\" en \"Warning: durations and segments do not match.\"}
					tk_messageBox -parent $tab -message \$mess($l)
				} elseif {(\[llength \$values\] < 2)} {
					array set mess {it \"Inserire almeno 2 valori.\" en \"Insert at least 2 values.\"}
					tk_messageBox -parent $tab -message \$mess($l)
				} else {
					tk_messageBox -parent $tab -message \"$corr = \[$corr \[$tab.$corr.entry1 get\] \[$tab.$corr.entry2 get\] \]\"
				}
			"] -columnspan 3
		}
	}
}

proc cambia_modo {} {
	global l
	global corrtipo
	if [winfo exists .cambia_modo] {focus .cambia_modo; return}
	toplevel .cambia_modo
	wm resizable .cambia_modo 0 0
	array set mess {it "Preferenze correlati" en "Correlates preferences"}
	wm title .cambia_modo $mess($l)
	
	array set mess {
		it "I correlati vengono calcolati in 2 diversi modi:\n\n(A) su tutti gli intervalli vocalici/consonantici di un TextGrid;\n\n(B) calcolando la media dei valori ottenuti per ogni intervallo interpausale.\n\nEntrambi i risultati (A e B) vengono mostrati nel report, ma è possibile scegliere quali utilizzare nei grafici."
		en "Rhythm metrics are computed in 2 different ways:\n\n(A) on all consonantal/vocalic intervals in a TextGrid;\n\n(B) as the mean of the values obtained for each inter-pausal string.\n\nBoth results (A and B) are shown in the report, but you can choose which you prefer to use when drawing charts."
	}
	grid [message .cambia_modo.msg -text $mess($l) -width 350] -columnspan 2 -pady 10
	
	foreach corr {Vperc Vdev Cdev varcoV varcoC Vrpvi Crpvi Vnpvi Cnpvi Vcci Ccci} {
		if {[rconfigure $corr] eq "B"} {set corrtipo($corr) B} else {set corrtipo($corr) A}
		ttk::label .cambia_modo.l$corr -text $corr
		ttk::combobox .cambia_modo.o$corr -textvariable corrtipo($corr) -values "A B" -width 2
		grid .cambia_modo.l$corr .cambia_modo.o$corr
	}
	
	#grid [ttk::frame .cambia_modo.btns] -columnspan 2 -pady {10 0}
	array set mess {it "Annulla" en "Cancel"}
	ttk::button .cambia_modo.annulla -text $mess($l) -image gif_chiudi -compound left -command {destroy .cambia_modo; return}
	ttk::button .cambia_modo.ok -text Ok -image gif_ok -compound left -command {
		foreach corr [array names corrtipo] {
			wconfigure $corr $corrtipo($corr)
		}
		destroy .cambia_modo
	}
	grid .cambia_modo.annulla .cambia_modo.ok -pady {15 0} -sticky we
}

proc cannot {verb {f "file"}} {
	global l
	if {$l eq "it" & $f eq "file"} {set f "il file"}
	if {$l eq "it" & $f eq "report"} {set f "il report"}
	array set mess1 {it "Impossibile aprire" en "Cannot open"}
	if {$verb eq "read"} {
		array set mess2 {
			it "Potrebbe dipendere dai permessi di lettura nella cartella, oppure il file potrebbe essere inesistente."
			en "This may depend on reading permissions, or this file may be inexistent."
		}
	} elseif {$verb eq "write"} {
		array set mess2 {
			it "Potrebbe dipendere dai permessi di scrittura nella cartella."
			en "This may depend on writing permissions."
		}
	}
	tk_messageBox -message "$mess1($l) $f.\n$mess2($l)"
}

proc apricartella {} {
	global l
	set cartella [tk_chooseDirectory]
	if {$cartella eq ""} {return}
	set files [glob -nocomplain [file join $cartella "*.TextGrid"]]
	if {[lindex $files 0] == ""} {
		array set message {it "Nessun file TextGrid trovato in questa cartella." en "No TextGrid found in this directory."}
		tk_messageBox -message $message($l)
		return
	}
	foreach file [lsort -dictionary $files] {
		if {[lsearch [.sx.b.paolo.lista_file get 0 end] $file] != -1} {continue}
		.sx.b.paolo.lista_file insert end $file
	}
	.sx.b.paolo.lista_file selection clear 0 end
	.sx.b.paolo.lista_file selection set end
	abdisab_segm
}

proc preparestring {stringa} {
	set stringa [string map {\" \\\"} $stringa]
	set stringa [string map {\[ \\\[} $stringa]
	set stringa [string map {\] \\\]} $stringa]
	set stringa [string map {\{ \\\{} $stringa]
	set stringa [string map {\} \\\}} $stringa]
}

proc txt2list {{parent .}} {
	set nomefile [tk_getOpenFile -parent $parent]
	if {$nomefile eq ""} {return ""}
	set file [open $nomefile r]
	set c [read $file]
	close $file
	set c [split $c "\n"]
	foreach item $c {
		if {$item eq ""} {continue} {lappend contenuto $item}
	}
	return $contenuto
}

proc importa {} {
	global l
	set contenuto [txt2list]
	if {$contenuto eq ""} {return}
	if [catch {
		set stdev [stdev $contenuto]
		set varco [varco $contenuto]
		set rpvi [rpvi $contenuto]
		set npvi [npvi $contenuto]
	}] {
		if {$l eq "it"} {set message "Errore; impossibile procedere.\nControllare che nel file siano presenti solo valori numerici."}
		if {$l eq "en"} {set message "Error; cannot proceed.\nCheck that the file contains exclusively numeric values."}
	} else {
		array set mess {it "Ecco i valori dei correlati del ritmo (CCI esclusi):\n" en "Here are the values of the rhythm correlates (except for CCIs):\n"}
		set message "$mess($l)\nstdev = $stdev\nvarco = $varco\nrpvi = $rpvi\nnpvi = $npvi"
	}
	tk_messageBox -message $message
}

proc btn {nome args} {
	button $nome -borderwidth 1
	if {$args ne ""} {eval [concat $nome configure $args]}
	set col [$nome cget -bg]
	bind $nome <Enter> "$nome configure -bg white"
	bind $nome <Leave> "$nome configure -bg $col"
	return $nome
}

proc abdisab {valore args} {
	if {($valore eq "") || ($valore == 0)} {set valore disabled} else {set valore normal}
	foreach w $args {
		catch {$w configure -state $valore}
	}
}

proc abdisab_segm {} {
	set sel [.sx.b.paolo.lista_file curselection]
	if {([llength $sel] == 1) && ($sel != -1)} {
		.sx.b.segmenti configure -state normal
		focus .sx.b.segmenti
		focus -force .
	} else {
		.sx.b.segmenti configure -state disabled
	}
	if {[.sx.b.paolo.lista_file size] > 1} {
		.sx.b.batch configure -state normal
	} else {
		.sx.b.batch configure -state disabled
	}
}

proc B_corr {corr tipo lista} {
	set TIPO [string toupper $tipo]
	set tipo [string tolower $tipo]
	set valori ""
	foreach item $lista {
		split $item \t
		set fono [lindex $item 0]
		set durata [lindex $item 1]
		if {[string match "*#*" $fono]} {
			if {[llength $valori] < 2} {set valori ""; continue}
			lappend parz [$corr $valori]
			set valori ""
		} elseif {[string match "*$tipo*" $fono] | [string match "*$TIPO*" $fono]} {
			lappend valori $durata
		}
	}
	if [info exists parz] {return "[mean $parz]\t0\t[format %.2f [stderr $parz]]"} else {return 0}
}

proc B_Vperc {lista} {
	set frasi [split_cvlist_into_sentences $lista]
	foreach frase $frasi {
		if [string match {*#*} $frase] {continue}
		set Vdur ""
		set Cdur ""
		foreach intervallo $frase {
			split $intervallo \t
			set fono [lindex $intervallo 0]
			set durata [lindex $intervallo 1]
			if [string match {*[Vv]*} $fono] {lappend Vdur $durata}
			if [string match {*[Cc]*} $fono] {lappend Cdur $durata}
		}
		set Vtot [sum $Vdur]
		set Ctot [sum $Cdur]
		if {($Vtot > 0) & ($Ctot > 0)} {
			lappend parz [expr ($Vtot / ($Vtot + $Ctot)) * 100]
		}
	}
	if [info exists parz] {return "[mean $parz]\t0\t[format %.2f [stderr $parz]]"} else {return 0}
}

proc B_cci {tipo lista} {
	set TIPO [string toupper $tipo]
	set tipo [string tolower $tipo]
	set valori ""
	set segmenti ""
	#set conto 0
	#set intervallo_interpausale 0
	foreach item $lista {
		#incr conto
		split $item \t
		set fono [lindex $item 0]
		set durata [lindex $item 1]
		if {[string match "*#*" $fono]} {
			if {[llength $valori] < 2} {
				#if {$conto == 1} {continue}
				#incr intervallo_interpausale
				#upvar log log
				#global l
				#array set mess0 {it "Errore nel calcolo dei correlati sui segmenti" en "An error occurred while calculating the metrics on"}
				#array set mess1 {it "dell'intervallo interpausale" en "segments of the interpausal string number"}
				#array set mess2 {it "impossibile calcolare i correlati su meno di 2 valori. Questo intervallo interpausale è stato ignorato." en "cannot calculate rhythm metrics on less than 2 values. This interpausal string has been ignored."}
				#lappend log "$mess0($l) $TIPO $mess1($l) $intervallo_interpausale: $mess2($l)"
				set valori ""
				set segmenti ""
			} else {
				#incr intervallo_interpausale
				lappend parz [cci $valori $segmenti]
				set valori ""
				set segmenti ""
			}
		} elseif {[string match "*$tipo*" $fono] | [string match "*$TIPO*" $fono]} {
			lappend segmenti $fono
			lappend valori $durata
		}
	}
	if [info exists parz] {return "[mean $parz]\t0\t[format %.2f [stderr $parz]]"} else {return 0}
}

proc extract_Bcorrelates {lista} {
	set durate_C ""
	set durate_V ""
	set trascrizione ""
	set conto 0
	set out "IPU,intC,intV,meanC,meanV,Cdev,varcoC,Crpvi,Cnpvi,Vdev,varcoV,Vrpvi,Vnpvi,intervals"
	foreach item $lista {
		split $item \t
		set fono [lindex $item 0]
		set durata [lindex $item 1]
		if {[string match "*#*" $fono]} {
			if {$durate_C eq "" & $durate_V eq ""} {continue}
			incr conto
			set mediaC [mean $durate_C]; if {$mediaC == 0} {set mediaC NA}
			set mediaV [mean $durate_V]; if {$mediaV == 0} {set mediaV NA}
			append out "\n$conto,[llength $durate_C],[llength $durate_V],$mediaC,$mediaV,"
			if {[llength $durate_C] < 2} {
				append out "NA,NA,NA,NA,"
			} else {
				append out "[stdev $durate_C],[varco $durate_C],[rpvi $durate_C],[npvi $durate_C],"
			}
			if {[llength $durate_V] < 2} {
				append out "NA,NA,NA,NA,"
			} else {
				append out "[stdev $durate_V],[varco $durate_V],[rpvi $durate_V],[npvi $durate_V],"
			}
			append out $trascrizione
			set durate_C ""
			set durate_V ""
			set trascrizione ""
		} elseif {[string match "*v*" $fono] | [string match "*V*" $fono]} {
			lappend durate_V $durata
			lappend trascrizione $fono
		} elseif {[string match "*c*" $fono] | [string match "*C*" $fono]} {
			lappend durate_C $durata
			lappend trascrizione $fono
		} else {
			lappend trascrizione $fono
		}
	}
	return $out
}

# Multiscroll
proc setScroll {s args} {
    eval [list $s set] $args
    eval [$s cget -command] [list moveto [lindex [$s get] 0]]
}
proc synchScroll {widgets args} {
    foreach w $widgets {eval [list $w] $args}
}
