# Questo file permette di fare le modifiche necessarie se vengono usate per la prima volta versioni nuove di Correlatore.
# Vengono fatte eventuali modifiche ai report e al file di configurazione che altrimenti darebbero problemi.

set l [rconfigure lingua]

if {[string match 1.0* [rconfigure versione]] || ([rconfigure versione] eq "")} {
	array set mess {
		it "Questa sembra essere la prima volta che si esegue la versione 2.0 di Correlatore su questo computer. Premendo Ok verranno aggiornati i report in modo da essere compatibili con questa nuova versione: assicurarsi di non aver rimosso alcun report dalla cartella di default prima di procedere.\nE' comunque consigliabile ricalcolare i correlati, soprattutto se sono stati calcolati con la procedura B (altrimenti verranno considerati come se fossero stati calcolati come A)."
		en "This seems to be the first time you execute version 2.0 of Correlatore. When you press Ok, all reports will be updated for compatibility with this new version, so please make sure that all reports are in their default location before continuing.\nHowever, you are strongly recommended to re-compute the metrics, above all if you used the B method (otherwise the values will be considered as if they had been calculated with procedure A)."
	}
	if {[tk_messageBox -message $mess($l) -type okcancel] ne "ok"} {exit}
	
	foreach report [glob [file join ~ .correlatore report *.txt] -nocomplain] {
		
		set f [open $report r]
		set contenuto [read $f]
		close $f
		
		set f [open $report w]
		foreach riga [split $contenuto \n] {
			if [regexp {^(FILE|intV|intC|pause|colour|border|symbol|--)} $riga] {
				puts $f $riga
			} else {
				puts $f $riga\t0
			}
			if [string match pause* $riga] {puts $f "Vmean\t0\nCmean\t0"}
		}
		close $f
		
	}
}

if {[string match 2.0* [rconfigure versione]]} {
	array set mess {
		it "Questa sembra essere la prima volta che si esegue la versione 2.1 di Correlatore su questo computer. Questa versione corregge alcuni bug presenti nella versione 2.0: è possibile che si ottengano risultati leggermenti diversi (e più precisi) dei delta, varco e PVI su file etichettati come CV."
		en "This seems to be the first time you execute versione 2.1 of Correlatore on this computer. This version corrects certain bugs of versione 2.0: you might get slightly different (and more precise) results for deltas, varcos and PVIs on textgrids labelled as CV."
	}
	tk_messageBox -message $mess($l)
}

wconfigure versione $::versione
